
import java.util.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/* Diese Klasse erzeugt ein neues Netzwerk unabhängig davon, ob die Aufgabe Rechen- oder
 * Theorieaufgabe ist. Die Anzahl der Stationen, die Länge der Verbindungen zwischen den
 * Stationen, die Anzahl Sendestationen und die Anzahl der zu sendenden Daten hängen vom
 * Schwierigkeitsgrad der Aufgabe ab.
 */
public class NetzwerkErzeugen {

  //int difficulty = 0;
  Netzwerk netzwerk = null;
  int übertragGeschwind;
  int[] min_Anz_Stationen = {
      3, 3, 3, 3, 3, 3, 4, 3, 4, 4, 3, 3, 4, 4, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6,
      6};
  boolean t = true, r = false;
  boolean[] aufg_Art = {
      t, r, r, t, r, t, r, t, r, r, t, r, t, r, t, r, t, r, t, r, t, r, t, r, t,
      r};
/*
 difficulty 1 - 5: Grund
 difficulty 6 - 10: Monitoring
 difficulty 11 - 14: Prio
 difficulty 15 -...: Prio mit Monitoring
 */

  int[] max_Anz_Stationen = {
      0, 0, 6, 1, 1, 1, 1, 1, 1, 1, 0, 0, 1, 1, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6,
      6};
  int[] übertrag_Geschwind = {
      10, 0, 10, 10, 10, 4, 4, 16, 16, 16, 4, 4, 16, 16, 16, 16, 16, 16, 16, 16,
      16, 16, 16, 16, 16, 16};
  int[] schwierig_Niveau = {
      1, 1, 1, 1, 1, 1, 2, 2, 3, 3, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 6, 7, 7, 7, 7,
      7};
  int count = 0;
  int fehlerImTokenPassing = 0;
  int anz_Stationen = 0;
  boolean passing, monitoring, priority;
  boolean zirkulierenderRahmen = false;
  boolean verlorenerRahmen = false;
  boolean zirkulierendesPrioToken = false;
  boolean verlorenesToken = false;

  public NetzwerkErzeugen() {
  }

  public Netzwerk erzeugeNetz(int difficulty) {

    /* ******************* Stationen erzeugen ************************ */
    Random r = new Random();

    if(difficulty > 25)
    {
      difficulty = 25;
    }

    if (difficulty == 3) {
      anz_Stationen = 4 + Math.abs(r.nextInt(7));
    }
    else {
      if (max_Anz_Stationen[difficulty - 1] == 0) {
        anz_Stationen = min_Anz_Stationen[difficulty - 1];
      }
      else {
        anz_Stationen = min_Anz_Stationen[difficulty - 1] +
            Math.abs(r.nextInt(max_Anz_Stationen[difficulty - 1]));
      }
    }
    if(difficulty == 2)
    {
      int index = r.nextInt(3);
      switch(index)
      {
        case 0: übertrag_Geschwind[difficulty-1] = 10; break;
        case 1: übertrag_Geschwind[difficulty-1] = 4; break;
        case 2: übertrag_Geschwind[difficulty-1] = 16; break;
      }
    }
    übertragGeschwind = übertrag_Geschwind[difficulty - 1];

    System.out.println("Anzahl Stationen " + anz_Stationen);

    fehlerImTokenPassing = 0; //reset

    netzwerk = new Netzwerk();
    netzwerk.setDifficulty(difficulty);
    netzwerk.setÜbertragGeschwind(übertragGeschwind);
    char buchstabe = 'A';

    Station.fertig.clear();
    for (int i = 0; i < anz_Stationen; i++) {
      Station station = new Station(netzwerk);
      netzwerk.addStation(station);
      station.setIndex(i);
      Station.fertig.add(new Boolean(false));
      station.setName("" + buchstabe);
      station.setTheorie(aufg_Art[difficulty-1]);
      buchstabe++;
    }
    /* ************** Verbindungen zwischen Stationen ************** */

    erzeugeVerbindungen(difficulty);
    System.out.println("Gesamtlänge des Ringes " + netzwerk.getTotalSize());

    /* ************** Aktiven Monitor auswählen ******************** */

    int ActivMonitorIndex = Math.abs(r.nextInt(anz_Stationen));
    Station activMonitor = (Station) netzwerk.getStationenListe().get(
        ActivMonitorIndex);
    activMonitor.setActivMonitor(true);
    System.out.println("Der aktive Monitor: " + activMonitor.getName());

    /* ************* Ring Purge Szenario ****************/


    if (difficulty > 5 && difficulty  < 11) {
      fehlerImTokenPassing = 1;  // + Math.abs(r.nextInt(4))
    }
    else {
      if (difficulty > 14 && aufg_Art[difficulty-1]) {
        fehlerImTokenPassing = Math.abs(r.nextInt(2)); //auf 5 setzen
        if(fehlerImTokenPassing != 0)
          count = 1;
      }
      if(difficulty > 14 && !aufg_Art[difficulty-1] && count !=0)
      {
        fehlerImTokenPassing = Math.abs(r.nextInt(2)); //auf 5 setzen
        if(fehlerImTokenPassing != 0)
          count = 0;
      }
    }
    switch (fehlerImTokenPassing) {
      case 0:
        zirkulierenderRahmen = false;
        break;
      case 1:
        zirkulierenderRahmen = true;
        System.out.println("Fehler: Zirklulierender Rahmen");
        break;
  /* !ab hier nicht implementiert! */
      case 2:
        verlorenerRahmen = true;
        System.out.println("Fehler: Verlorener Rahmen");
        break;
      case 3:
        zirkulierendesPrioToken = true;
        System.out.println("Fehler: Zirklulierendes PrioToken");
        break;
      case 4:
        verlorenesToken = true;
        System.out.println("Fehler: Verlorenes Token");
        break;
    }

    /* ************** SenderStationen festlegen ******************** */
    if (difficulty == 1 || difficulty > 3) {
      Vector hilfsIndizes = new Vector();
      for (int i = 0; i < anz_Stationen; i++) {
        hilfsIndizes.add(new Integer(i));
      }
      int anz_SendeStationen = 2 +
          Math.abs(r.nextInt()) % (anz_Stationen / 2 + 1); //ändern
      System.out.println("Anzahl der sendewilligen Stationen " +
                         anz_SendeStationen);
      int indexZufall, indexInhalt;
      for (int i = 0; i < anz_SendeStationen; i++) {
        indexZufall = Math.abs(r.nextInt(hilfsIndizes.size()));
        indexInhalt = ( (Integer) hilfsIndizes.remove(indexZufall)).intValue();
        Station sendeStation = (Station) netzwerk.getStationenListe().get(
            indexInhalt);
        netzwerk.addSendeStation(sendeStation);

        int anz_PDU = Math.abs(r.nextInt());
        int prioritaet = 0;
        if (difficulty > 10) {
          priority = true;
        }

        int groesse = 0;
        switch (übertragGeschwind) {
          case 4:
            groesse = 4000; //5000
          case 10:
            groesse = 11000; //12500
          case 16:
            groesse = 18000; //20000
        }

        int n = 1 + Math.abs(r.nextInt(schwierig_Niveau[difficulty - 1]));
        System.out.println("Position in der Queue der Sendestationen " + i +
                           " Station: " + sendeStation.getName());
        for (int j = 0; j < n; ) {
          int indexZufall2 = Math.abs(r.nextInt(netzwerk.getStationenListe().
                                                size()));
          Station zielStation = (Station) netzwerk.getStationenListe().get(
              indexZufall2);
          if (sendeStation != zielStation) {
            if (priority) {
              prioritaet = Math.abs(r.nextInt(4));
            }
            PDU pdu = new PDU(groesse, prioritaet, zielStation, sendeStation);
            sendeStation.addPDU(pdu);
            sendeStation.addPDURedundant(pdu);
            netzwerk.addPDU(pdu);
            System.out.println(j + ". PDU mit Prio " + prioritaet + " an " +
                               zielStation.getName());
            j++;
          }
        }
      }
      if (zirkulierenderRahmen) {
        //Vorläufig den Aktiven Monitor aus der Liste der SendeStationen entfernen,
        //damit er nicht zufällig ausgewählt wird, um einen Fehler einzubauen
        Station activerMonitor = null;
        int index = 0;
        for(int i = 0; i < netzwerk.getSendeStationenListe().size(); i++)
        {
          if(((Station)netzwerk.getSendeStationenListe().get(i)).getActivMonitor())
          {
            activerMonitor = (Station)netzwerk.getSendeStationenListe().get(i);
            netzwerk.getSendeStationenListe().remove(i);
            index = i;
          }
        }

        int indexZufallRP = Math.abs(r.nextInt(netzwerk.getSendeStationenListe().
                                               size()));
        Station stationFehlerImTokenPassing = (Station) netzwerk.getSendeStationenListe().get(indexZufallRP);

        System.out.print(stationFehlerImTokenPassing.getName() +
                         ": wird einen Fehler einbauen ");
        int indexZufallRPPDU = Math.abs(r.nextInt(stationFehlerImTokenPassing.
                                                  getPDUQueue().size()));
        stationFehlerImTokenPassing.setZirkulierendePDUIndex(indexZufallRPPDU);
        stationFehlerImTokenPassing.setFehler(true);
        PDU pduRP = (PDU) stationFehlerImTokenPassing.getPDUQueue().get(
            indexZufallRPPDU);

        pduRP.setFehler(true);
        if(activerMonitor != null)
        netzwerk.getSendeStationenListe().add(index, activerMonitor);
        System.out.println("PDU Nr " + indexZufallRPPDU + " adressiert an: " +
                           pduRP.getDestinationStation().getName());
      }
    }
    /* *************** Position des Token festlegen *************** */
    Rahmen token = netzwerk.getRahmen();
    int tokenPosition = Math.abs(r.nextInt(netzwerk.getStationenListe().size()));
    token.setPosition(netzwerk.getStationenListe().get(tokenPosition));
    ( (Station) token.getPosition()).setFrame(token);
    System.out.println("Token ist bei " +
                       ( (Station) token.getPosition()).getName());

    return netzwerk;
  }

  public void erzeugeVerbindungen(int difficulty) {
    int anz_Verbindungen = netzwerk.getStationenListe().size(); //Verbindungen zwischen Stationen, Beziehungen zwischen Stationen
    Random r = new Random();
    int laenge = 1000 + 100 * Math.abs(r.nextInt(6));
    System.out.println(laenge);
    for (int i = 0; i < anz_Verbindungen; i++) {
      Station endStation = null;
      if (i == anz_Verbindungen - 1) {
        endStation = (Station) netzwerk.getStationenListe().getFirst();
      }
      else {
        endStation = (Station) netzwerk.getStationenListe().get(i + 1);
      }
      if(difficulty > 17)
      {
        laenge = 500 + 100 * Math.abs(r.nextInt(6));
        System.out.println(laenge);
      }

      Station anfangsStation = (Station) netzwerk.getStationenListe().get(i);
      Verbindung verbindung = new Verbindung(laenge, anfangsStation, endStation);
      anfangsStation.setDownstreamConnection(verbindung);
      endStation.setUpstreamConnection(verbindung);
      anfangsStation.setSuccessor(endStation);
      endStation.setPredecessor(anfangsStation);

      netzwerk.addVerbindung(verbindung);

      /* ***************************** */
    }

  }

  public static void main(String[] args) {
    NetzwerkErzeugen erzeuge = new NetzwerkErzeugen();
    int difficulty = 9;
    Netzwerk netzwerk = erzeuge.erzeugeNetz(difficulty);
/*    if(difficulty == 2)
    {
      AufgabeGrundR1 grundRechenaufgabe = new AufgabeGrundR1(netzwerk);
      System.out.println(grundRechenaufgabe.getAufgabenstellung());
      System.out.println(grundRechenaufgabe.getSolution());
    }
    if (difficulty == 3)
    {
      AufgabeGrundR2 grundRechenaufgabe = new AufgabeGrundR2(netzwerk);
      System.out.println(grundRechenaufgabe.getAufgabenstellung());
      System.out.println(grundRechenaufgabe.getSolution());
    }
    if (difficulty > 3) {
      netzwerk.startTimer();
      TokenRingManager tokenRingThread = new TokenRingManager(netzwerk);
      tokenRingThread.start();
    }*/

  }
}