
import java.util.*;
import viror.teach.anim.net.*;
import java.awt.*;
import java.beans.PropertyVetoException;
import javax.swing.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description:
 * Kontrollinstanz der Animation. Reagiert auf den Empfang eines Rahmens durch
 * den Knoten (Router) und ruft die Rahmen-Empfangs-Methode (dataReceive) der zugehörigen Station
 * auf, dann je nach dem wie sich der Rahmen-Typ verändert hat, wird das entsprechende
 * Bild für die Darstellung des Rahmens gewählt.
 * Stoppt die Animation, wenn alle Stationen fertig mit der Übertragung ihrer Daten sind.
 * </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/*
 */
class RahmenHandler
    extends SimpleParseHandler {

  private Netzwerk netzwerk;
  private Router homeRouter;
  private Station station;
  private viror.teach.anim.net.Package Paket;
  private NetworkSemantics sem;
  private boolean Progressive;
  private MainFrame mainFrame;

  public RahmenHandler(Netzwerk netzwerk, Router router, Station station, MainFrame frame,
                       NetworkSemantics sem) {
    super(router);
    this.homeRouter = router;
    this.netzwerk = netzwerk;
    this.station = station;
    this.mainFrame = frame;
    this.sem = sem;
    this.Progressive = true;
  }

  public void handlePackage(viror.teach.anim.net.Package p) {
    Image image = null;
    int pakType = 0;
    mainFrame.addAusgabeText(station.receiveData(netzwerk.getRahmen()));
    int index = 0;
    for (int i = 0; i < Station.fertig.size(); i++) {
      if ( ( (Boolean) Station.fertig.get(i)).booleanValue())
        index++;
    }
    if (index == Station.fertig.size())
    {
      p.getPath().removeActor(p);
      p.getAnimList().suspendAnim();
      mainFrame.setButtons(6);
    }
    else {
      if (netzwerk.getRahmen().getTokenBit()) {
        if (netzwerk.getRahmen().getPriority() != 0) {
          image = sem.getImage("Prio");
          pakType = 1;
        }
        else {
          image = sem.getImage("Token");
          pakType = 0;
        }
      }
      else {
        if (netzwerk.getRahmen().getFCRingPurge()) {
          image = sem.getImage("RPF");
          pakType = 2;
        }
        else {
          image = sem.getImage("Frame");
          pakType = 3;
        }
      }

      p.getPath().removeActor(p);

      try {
        Paket = new viror.teach.anim.net.Package(pakType, 4, image, image);
        Paket.scalePeer(1.5);
        Paket.setTravelTime(5);
      }
      catch (java.beans.PropertyVetoException e) {
        System.err.println("Oh_dear_"); // should be impossible!
      }

      if (Progressive) {
        fireProgress(1, true);
      }
      int i = netzwerk.getStationenListe().indexOf(station.getSuccessor());
      Router[] stationenListe = mainFrame.getStationenListe();
      homeRouter.sendPackage(Paket, homeRouter.getLink(stationenListe[i]));
      p.getList().removeElement(p);
    }
  }
}