
import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/*
 * Teil der GUI, in dem angezeigt wird, welche Stationen Daten zu versenden haben,
 * an wen diese Daten adressiert sind und welche Priorität sie haben.
 */
public class SendeStationenPanel
    extends JPanel {

  private JPanel west = new JPanel();
  private JPanel east = new JPanel();

  public SendeStationenPanel() {
    this.setLayout(new BorderLayout());
    this.add(west, BorderLayout.WEST);
    this.add(east, BorderLayout.EAST);
  }

  public void setSendeStationen(Netzwerk netzwerk) {
    //removeAll();
    west.removeAll();
    east.removeAll();
    west.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 10));
    east.setBorder(BorderFactory.createEmptyBorder(2, 10, 2, 10));
    west.setLayout(new GridLayout(netzwerk.getSendeStationenListe().size(), 1));
    east.setLayout(new GridLayout(netzwerk.getSendeStationenListe().size(), 1));
    Station station;
    TreeSet sendeStationen = new TreeSet();
    for(int i = 0; i < netzwerk.getSendeStationenListe().size(); i++)
    {
      sendeStationen.add((Station)netzwerk.getSendeStationenListe().get(i));
    }
    Iterator it = sendeStationen.iterator();

    for (int i = 0; it.hasNext(); i++) {
      station = (Station) it.next();
      JLabel name = new JLabel();
      name.setText(station.getName());
      west.add(name);
      JPanel eastPanel = new JPanel();
      eastPanel.setLayout(new GridLayout(station.getPDUQueue().size(), 1));
      JLabel PDU = new JLabel();
      for (int j = 0; j < station.getPDUQueue().size(); j++) {
        JLabel pdu = new JLabel();
        JPanel pduPanel = new JPanel();
        FlowLayout pduPanellayout = new FlowLayout();
        pduPanellayout.setAlignment(FlowLayout.LEFT);
        pduPanel.setLayout(pduPanellayout);

        String string = (j + 1) + ". PDU to " +
                    ( (PDU) station.getPDUQueue().get(j)).getDestinationStation().getName() +
                    (netzwerk.getDifficulty() > 10 ? " with Prio " +
                    ( (PDU) station.getPDUQueue().get(j)).getPriority() : "");
        pdu.setText(string);
        if(((PDU) station.getPDUQueue().get(j)).getFehler())
        {
          pdu.setForeground(Color.RED);
        }
        eastPanel.add(pdu);
      }
      east.add(eastPanel);
    }
  }
}