import java.util.*;
import java.io.*;
import java.math.BigDecimal;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/*
 * Enthält die rahmenverarbeitende Logik
 */
class Station
    implements Comparable {
  private String name;
  private boolean stackingStation;
  private boolean activMonitor;
  private Station vorgaenger;
  private Station nachfolger;
  private int rRegister, pRegister; //Reservierung und Priorität des empfangenen Rahmen bzw. Token
  private LinkedList PDUqueue;
  private LinkedList PDUqueueAbgearbeitet;
  private Stack Sr; //alte Ring-Service-Priorität
  private Stack Sx; //neue Ring-Service-Priorität
  private Verbindung upstream;
  private Verbindung downstream;
  private Rahmen rahmen;
  private float sendeZeitpunkt, empfangsZeitpunkt;
  private float tok = 24/1000f;
  private float rpf = 800/1000f;
  private Netzwerk netzwerk;
  private Vector ausgabe;
  private int zirkulierendePDU;
  private boolean fehler;
  private boolean theorie;
  private boolean lösung;
  private int index;
  public static LinkedList fertig = new LinkedList(); //Liste, in die alle Stationen ihren Sende-Fortschritt eintragen
  private ArrayList zeitenListe = new ArrayList();
  private Iterator it = zeitenListe.iterator();
  private int indexZeit = 0;

  public Station(Netzwerk netzwerk) {
    this.netzwerk = netzwerk;
    PDUqueue = new LinkedList();
    PDUqueueAbgearbeitet = new LinkedList();

    Sr = new Stack();
    Sx = new Stack();
    rRegister = 0;
    pRegister = 0;

    fehler = false;
    theorie = true;
    lösung = false;
    ausgabe = new Vector();
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public void setPredecessor(Station vorgaenger) {
    this.vorgaenger = vorgaenger;
  }

  public Station getPredecessor() {
    return vorgaenger;
  }

  public void setSuccessor(Station nachfolger) {
    this.nachfolger = nachfolger;
  }

  public Station getSuccessor() {
    return nachfolger;
  }

  public void setUpstreamConnection(Verbindung upstream) {
    this.upstream = upstream;
  }

  public Verbindung getUpstreamConnection() {
    return upstream;
  }

  public void setDownstreamConnection(Verbindung downstream) {
    this.downstream = downstream;
  }

  public Verbindung getDownstreamConnection() {
    return downstream;
  }

  public void setActivMonitor(boolean activMonitor) {
    this.activMonitor = activMonitor;
  }

  public boolean getActivMonitor() {
    return activMonitor;
  }

  public void setStackingStation(boolean stackingStation) {
    this.stackingStation = stackingStation;
  }

  public boolean getStackingStation() {
    return stackingStation;
  }

  public void setFrame(Rahmen rahmen) { //START evtl. vorläufig
    this.rahmen = rahmen;
  }

  public void addPDU(PDU pdu) {
    PDUqueue.add(pdu);
  }

  public LinkedList getPDUQueue() {
    return PDUqueue;
  }

  public LinkedList getPDUqueueAbgearbeitet() {
    return PDUqueueAbgearbeitet;
  }

  public void addPDURedundant(PDU pdu) {
    PDUqueueAbgearbeitet.add(pdu);
  }

  public void setIndex(int index) {
    this.index = index;
  }

  public Vector receiveData(Rahmen rahmen) {
    ausgabe.clear();
    return receiveData_(rahmen);
  }

  public Netzwerk getNetzwerk() {
    return netzwerk;
  }

  public Vector receiveData_(Rahmen _rahmen) {

    empfangsZeitpunkt = netzwerk.getTimer().getCurrentTime();
    if(!lösung)
    {
      BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
      bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
      zeitenListe.add(new Float(bd.floatValue()));
    }
    if(lösung & !theorie)
      if(indexZeit < zeitenListe.size())
      {
        ausgabe.add(new String(name+" receives at t = " +
                               ( ((Float)zeitenListe.get(indexZeit)).floatValue())));
        indexZeit++;
      }
    System.out.println("Empfangszeitpunkt: " + empfangsZeitpunkt);
    System.out.println("Station " + name + " hat " +
                       (_rahmen.getTokenBit() == true ? "Token" : "Rahmen") +
                       " empfangen");
    this.rahmen = _rahmen;
    rRegister = rahmen.getReservierung();
    pRegister = rahmen.getPriority();

    /* ************* Empfangener Rahmen ist kein Token ************ */
    if (!rahmen.getTokenBit()) {

      /* ******** Empfangener Rahmen ist ein Ring-Purge-Frame ******** */
      if (rahmen.getFCRingPurge()) {
        receiveRingPurgeFrame();
        sendFrame();
      }
      else { //kein Ring-Purge-Frame

        if (activMonitor && rahmen.getMonitorBit())
        /* Ein zirkulierender Rahmen wurde vom Monitor empfangen */
        {
          rahmen.reset();
          rahmen.setFCRingPurge(true);
          rahmen.resetTokenBit();
          rahmen.addPDU(new PDU(27, 0, null, this));
          stackingStation = false;
          Sx.clear();
          Sr.clear();
          netzwerk.getTimer().updateCurrentTime(rpf /
              netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)

          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          ausgabe.addElement(new String(name +
                                        " receives a frame with M = 1"));
          System.out.println(name +
              ": Zirkulierender Rahmen vom Monitor empfangen & vom Netz genommen");
          ausgabe.addElement(new String(name + " transmits a ring purge frame"));
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }

          System.out.println(name + " transmits a ring purge frame");
          sendFrame();
        }

        else
        /* Ein normaler Rahmen wurde empfangen */
        {
          if (rahmen.getPDU().getFehler() &&
              rahmen.getPDU().getSenderStation().getName().equals(getName())) {
            rahmen.getPDU().setFehler(false);
            sendFrame();
          }
          else {
            receiveFrame();
            sendFrame();
          }
        }
      }
    }
    /* ************* Ist ein Token ************** */
    else {
      if (activMonitor && rahmen.getPriority() != 0 && rahmen.getMonitorBit())
      /* Ein zirkulierender PrioToken wurde empfangen */
      {
        rahmen.reset();
        rahmen.setFCRingPurge(true);
      }
      else {
        receiveToken();
      }
      sendFrame();
    }
    return ausgabe;
  }

  public void sendFrame() {
    if (PDUqueue.isEmpty() && !stackingStation) {
      if(rahmen.getTokenBit())
        fertig.set(index, new Boolean(true));
      else
      {
        if(!rahmen.getPDU().getSenderStation().getName().equals(name))
        {
          fertig.set(index, new Boolean(true));
        }
      }
      System.out.println("Station " + name + " has no more PDUs to send...");
    }
    else {
      fertig.set(index, new Boolean(false));
    }
    rahmen.setPosition(downstream);

    downstream.setFrame(rahmen);
  }

  public void receiveToken() {
    System.out.println(name + " receives a priotoken with P = " +
                       rahmen.getPriority() +
                       " and R = " + rahmen.getReservierung());

    /* Normaler Token Passing Betrieb*/
    if (!PDUqueue.isEmpty()) { //PDUs zu versenden da
      PDU pdu = (PDU) PDUqueue.getFirst();

      /* ********** eigentlicher Sendevorgang ********* */

      if (pRegister <= pdu.getPriority()) { //PDU mit genügend hoher Priorität
        if (pdu.getFehler()) {
          rahmen.addPDU(pdu);
          rahmen.setPriority(pRegister);
          rahmen.setReservierung(0);
          rahmen.resetMonitorBit();
          if (!lösung) {
            pdu.setEmpfangsZeitpunkt(empfangsZeitpunkt);
          }
          System.out.println("Empfangszeitpunkt: " + empfangsZeitpunkt);
          netzwerk.getTimer().updateCurrentTime(10f); //10ms THT, sonst 0.01 s
          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          sendeZeitpunkt = empfangsZeitpunkt + 10f; //10ms THT, sonst 0.01 s

          if (!lösung) {
            pdu.setSendeZeitpunkt(sendeZeitpunkt);
          }
          System.out.println("Sendezeitpunkt: " + sendeZeitpunkt);

          if (netzwerk.getDifficulty() < 11) {

            ausgabe.addElement(new String(name + " transmits its own frame"));
          }
          else {
            ausgabe.addElement(new String(name +
                                          " transmits its own frame with P = " +
                                          rahmen.getPriority()
                                          + " and R = " +
                                          rahmen.getReservierung()));
          }
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }
          System.out.println(name + ": eigenen Rahmen senden" + " mit Prio " +
                             rahmen.getPriority());
        }
        else {
          rahmen.addPDU(pdu);
          rahmen.setPriority(pRegister);
          rahmen.setReservierung(0);
          rahmen.resetMonitorBit();
          System.out.println("Sendezeitpunkt: " + sendeZeitpunkt);
          netzwerk.getTimer().updateCurrentTime(10f); //0.01f
          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          PDUqueue.removeFirst();
          netzwerk.getGlobalPDUqueue().removeFirst();
          if (netzwerk.getDifficulty() < 11) {
            ausgabe.addElement(new String(name + " transmits its own frame"));
          }
          else {
            ausgabe.addElement(new String(name +
                                          " transmits its own frame with P = " +
                                          rahmen.getPriority()
                                          + " and R = " +
                                          rahmen.getReservierung()));

          }
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }
          System.out.println(name + ": eigenen Rahmen senden" + " mit Prio " +
                             rahmen.getPriority());
        }
      }

      /* ********************************************** */

      else { //Priorität der PDU niedriger als aktuelle Priorität
        if (rRegister < pdu.getPriority()) {
          rahmen.setReservierung(pdu.getPriority());
          rRegister = pdu.getPriority();
          ausgabe.addElement(new String(name +
                                        " sets the reservation bits R = " +
                                        rahmen.getReservierung()));
          System.out.println(name + ": Reservierung =" +
                             rahmen.getReservierung() + " vornehmen im Token");
        }
        if (stackingStation) {
          if (!Sx.isEmpty() && !Sr.isEmpty()) { //Stacks sind nicht leer (?)
            Integer sx = (Integer) Sx.peek();
            Integer sr = (Integer) Sr.peek();

            if (sx.intValue() < pRegister) { //Prio'token höherer Priorität empfangen
              if (activMonitor) { //ÄNDERN
                rahmen.setMonitorBit();
                if (netzwerk.getDifficulty() > 5) {
                  ausgabe.addElement(new String(name + " sets the monitor bit"));
                }
                System.out.println(name + ": MonitorBit setzen 2");
              }
            }
            if (sx.intValue() > pRegister) { //Prio'token niedriger Priorität
              Sx.clear();
              Sr.clear();
              System.out.println(name + ": Stacks leeren");
            }

            if (sx.intValue() == pRegister) { //Prio'token von der Station erzeugt
              /* der Fall, dass die Reservierung größer ist als die aktuelle
                   Priorität eines Tokens kann nicht eintreten (?)
                   deswegen ist nur der Vergleich mit der vorherigen Priorität des
                   Ringes ausreichend
               */

              if (sr.intValue() < rRegister) {
                //Sx.pop();
                int sxPop = ( (Integer) Sx.pop()).intValue();
                System.out.println(name +
                    ": Alten Wert aus dem neuen Stack entfernen: " +
                    sxPop);
                Sx.push(new Integer(rRegister));
                System.out.println(name +
                                   ": in den neuen Stack neuen Wert einfügen: " +
                                   ( (Integer) Sx.peek()).intValue());
                //System.out.println("");
                rahmen.reset();
                rahmen.setPriority(rRegister);
                netzwerk.getTimer().updateCurrentTime(tok /
                    netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)
                if(!lösung)
                {
                  BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
                  bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
                  zeitenListe.add(new Float(bd.floatValue()));
                }

                ausgabe.addElement(new String(name +
                    " generates a new priotoken with P = " +
                    rahmen.getPriority() +
                    " and R = " +
                    rahmen.getReservierung()));
                if(lösung & !theorie)
                  if(indexZeit < zeitenListe.size())
                  {
                    ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
                    indexZeit++;
                  }

                System.out.println(name +
                                   ": erzeugt Neues PriToken mit Priorität = " +
                                   rahmen.getPriority() +
                                   " und Reservierung = " +
                                   rahmen.getReservierung());
                System.out.println("Neuer Stack: " +
                                   ( (Integer) Sx.peek()).intValue() +
                                   " Size: " + Sx.size() +
                                   "; Alter Stack:" +
                                   ( (Integer) Sr.peek()).intValue() +
                                   " Size: " + Sr.size()
                                   );
              }
              else {
                rahmen.reset();
                rahmen.setPriority(sr.intValue());
                rahmen.setReservierung(rRegister);
                int sxPop = ( (Integer) Sx.pop()).intValue();
                System.out.println(name +
                    ": Alten Wert aus dem neuen Stack entfernen: " +
                    sxPop);
                int srPop = ( (Integer) Sr.pop()).intValue();
                System.out.println(name +
                                   ": Alten Wert aus dem alten Stack entfernen: " +
                                   srPop);
                netzwerk.getTimer().updateCurrentTime(tok /
                    netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)

                if(!lösung)
                {
                  BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
                  bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
                  zeitenListe.add(new Float(bd.floatValue()));
                }

                if (rahmen.getPriority() != 0) {

                  ausgabe.addElement(new String(name +
                      " generates a new priotoken with P = " +
                      rahmen.getPriority() + " and R = " +
                      rahmen.getReservierung()));
                }
                else {
                  ausgabe.addElement(new String(name +
                                                " generates a new token"));
                }

                System.out.println(name +
                    ": Neues PrioToken mit heruntergesetzten Prio = " +
                    rahmen.getPriority() + " erzeugen");
                if (Sr.isEmpty() && Sx.isEmpty()) {
                  stackingStation = false;
                  ausgabe.addElement(new String(name +
                      " discontinues its role as a stacking station"));
                  System.out.println(name +
                                     " hört auf Stacking Station zu sein");
                }
                if(lösung & !theorie)
                  if(indexZeit < zeitenListe.size())
                  {
                    ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
                    indexZeit++;
                  }
              }
            }
          }
        }

        else { //keine Stacking Station
          if (activMonitor) {
            rahmen.setMonitorBit();
            if (netzwerk.getDifficulty() > 5) {
              ausgabe.addElement(new String(name + " sets the monitor bit"));
            }
            System.out.println(name + ": MonitorBit setzen 3");
          }
        }
      }
    }
    else { //keine PDUs zu versenden
      System.out.println(name + " Station hat keine PDU zu versenden");
      if (netzwerk.getDifficulty() < 6) {
        ausgabe.addElement(new String(name + " repeats the token"));
      }
      if (pRegister != 0) {
        if (activMonitor) {
          rahmen.setMonitorBit();
          if (netzwerk.getDifficulty() > 5) {
            ausgabe.addElement(new String(name + " sets the monitor bit"));
          }
          System.out.println(name + ": MonitorBit setzen 4");
        }
        if (stackingStation) {
          System.out.println(name + " ist Stacking Station");
          System.out.println("Neuer Stack (Anzahl Elemente): " + Sx.size() +
                             "; Alter Stack (Anzahl Elemente): " + Sr.size());
          System.out.println("Neuer Stack 1.Ele " +
                             ( (Integer) Sx.peek()).intValue()
                             + "; AlterStack 1.Ele " +
                             ( (Integer) Sr.peek()).intValue());
          System.out.println("Prio im Token = " + pRegister +
                             " Reservierung im Token = " + rRegister);

          if ( ( (Integer) Sx.peek()).intValue() > pRegister) {
            System.out.println( ( (Integer) Sx.peek()).intValue() + " > " +
                               pRegister);
            Sx.clear();
            Sr.clear();
            System.out.println(name + ": Stacks leeren");
          }

          if ( ( (Integer) Sx.peek()).intValue() == pRegister) {
            System.out.println( ( (Integer) Sx.peek()).intValue() + " == " +
                               pRegister);
            if ( ( (Integer) Sr.peek()).intValue() < rRegister) {
              System.out.println( ( (Integer) Sr.peek()).intValue() + " < " +
                                 rRegister);
              int sxPop = ( (Integer) Sx.pop()).intValue();
              System.out.println(name +
                  ": Alten Wert aus dem neuen Stack entfernen: " +
                  sxPop);
              Sx.push(new Integer(rRegister));
              System.out.println(name +
                                 ": Neuen Wert in den neuen Stack einfügen " +
                                 ( (Integer) Sx.peek()).intValue());
              rahmen.reset();
              rahmen.setPriority(rRegister);
              netzwerk.getTimer().updateCurrentTime(tok /
                  netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)

              if(!lösung)
              {
                BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
                bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
                zeitenListe.add(new Float(bd.floatValue()));
              }

              if (rahmen.getPriority() != 0) {

                ausgabe.addElement(new String(name +
                    " generates a new priotoken with P = " +
                    rahmen.getPriority() + " and R = " +
                    rahmen.getReservierung()));
              }
              else {

                ausgabe.addElement(new String(name +
                                              " generates a new token"));
              }
              if(lösung & !theorie)
                if(indexZeit < zeitenListe.size())
                {
                  ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
                  indexZeit++;
                }

              System.out.println(name +
                                 ": neues PrioToken mit reservierter Prio " +
                                 rahmen.getPriority() + " erzeugen");
            }
            else {
              System.out.println( ( (Integer) Sr.peek()).intValue() +
                                 " = oder > " + rRegister);
              rahmen.reset();
              rahmen.setPriority( ( (Integer) Sr.peek()).intValue());
              rahmen.setReservierung(rRegister);
              netzwerk.getTimer().updateCurrentTime(tok /
                  netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)

              if(!lösung)
              {
                BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
                bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
                zeitenListe.add(new Float(bd.floatValue()));
              }

              int sxPop = ( (Integer) Sx.pop()).intValue();
              System.out.println(name +
                  ": Alten Wert aus dem Neuen Stack entfernen: " +
                  sxPop);
              int srPop = ( (Integer) Sr.pop()).intValue();
              System.out.println(name +
                  ": Alten Wert aus dem Altem Stack entfernen: " +
                  srPop);
              if (Sx.isEmpty() && Sr.isEmpty()) {
                stackingStation = false;

                ausgabe.addElement(new String(name +
                    " discontinues its role as a stacking station"));
                System.out.println(name +
                                   ": hört auf Stacking Station zu sein");
              }
              if (rahmen.getPriority() != 0) {
                ausgabe.addElement(new String(name +
                    " generates a new priotoken with P = " +
                    rahmen.getPriority() + " and R = " +
                    rahmen.getReservierung()));
              }
              else {
                ausgabe.addElement(new String(name +
                                              " generates a new token"));
              }
              if(lösung & !theorie)
                if(indexZeit < zeitenListe.size())
                {
                  ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
                  indexZeit++;
                }

              System.out.println(name +
                                 ": neues Priotoken mit alter Prio " +
                                 rahmen.getPriority() + " und Reservierung " +
                                 rahmen.getReservierung() + " erzeugen");
            }
          }
        }
      }
    }
  }

  public void receiveRingPurgeFrame() {
    if (activMonitor) {

      /* **** Station hat den eigenen Ring-Purge-Frame empfangen **** */
      if (rahmen.getPDU().getSenderStation().getName().equals(getName())) {
        ausgabe.addElement(new String(name +
                                      " strips the ring purge frame from the ring"));
        System.out.println(name + ": eigenen RP-Frame empfangen");
        netzwerk.getTimer().updateCurrentTime(tok /
            netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)

        if(!lösung)
        {
          BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
          bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
          zeitenListe.add(new Float(bd.floatValue()));
        }

        if (rahmen.getReservierung() == 0) {
          rahmen.reset();
          ausgabe.addElement(new String(name + " generates a new token"));
        }
        else {
          stackingStation = true;
          rahmen.reset();
          rahmen.setPriority(rRegister);
          ausgabe.addElement(new String(name +
                                        " generates a new priotoken with P = "
                                        + rahmen.getPriority() + " and R = " +
                                        rahmen.getReservierung()));
        }
        if(lösung & !theorie)
          if(indexZeit < zeitenListe.size())
          {
            ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
            indexZeit++;
          }

      }
      else { //RP-Frame von einer anderen Station
        activMonitor = false;
        if (stackingStation) {
          ausgabe.addElement(new String(name +
              " discontinues its role as a stacking station"));
        }
        stackingStation = false;
        Sx.clear();
        Sr.clear();
      }
    }
    else { //kein aktiver Monitor
      if (stackingStation) {
        ausgabe.addElement(new String(name +
            " discontinues its role as a stacking station"));
      }
      stackingStation = false;
      Sx.clear();
      Sr.clear();
    }
  }

  public void receiveFrame() {
    if (activMonitor) {
      if (!rahmen.getPDU().getSenderStation().getName().equals(getName())) {
        rahmen.setMonitorBit();
        if (netzwerk.getDifficulty() > 5) {
          ausgabe.addElement(new String(name + " sets the monitor bit"));
        }
        System.out.println(name + " MonitorBit setzen 1");
      }
    }
    if (rahmen.getPDU().getSenderStation().getName().equals(getName())) { //eigener Frame
      if(!rahmen.getPDU().getFehler())
      {
        if (netzwerk.getDifficulty() > 10) {
          ausgabe.addElement(new String(name +
                                        " receives its own frame with P = " +
                                        rahmen.getPriority() +
                                        " and R = " + rahmen.getReservierung()));
        }
        else {
          ausgabe.addElement(new String(name + " receives its own frame"));
        }
      }
      System.out.println("Empfangener eigener Rahmen adressiert an " +
                         rahmen.getPDU().getDestinationStation().getName() +
                         " hat Prio: " + rahmen.getPriority() +
                         " und Reservierung: " + rahmen.getReservierung());
      if (!PDUqueue.isEmpty() &&
          ( (PDU) PDUqueue.getFirst()).getPriority() >=
          rahmen.getReservierung()) { //noch PDUs zu versenden da
        PDU pdu = (PDU) PDUqueue.getFirst();
        //Priorität der PDU >= der aktuellen Reservierung

        if (pdu.getPriority() > rahmen.getPriority()) { //Priorität der PDU > aktuelle Priorität
          rahmen.reset();
          rahmen.setPriority(pdu.getPriority());

          System.out.println("Neue Prio im Rahmen: " + rahmen.getPriority() +
                             "; PDUPrio: " + pdu.getPriority());

          stackingStation = true;
          Sx.push(new Integer(rahmen.getPriority()));
          System.out.println(name + ": Neuen Stack mit neuem Wert füllen = " +
                                ( (Integer) Sx.peek()).intValue());
          Sr.push(new Integer(pRegister));
          System.out.println(name + ": Alten Stack mit neuem Wert füllen = " +
                                ( (Integer) Sr.peek()).intValue());
          ausgabe.addElement(new String(name + " becomes a stacking station"));
          netzwerk.getTimer().updateCurrentTime(tok /
              netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)
          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          ausgabe.addElement(new String(name +
                                        " generates a new priotoken with P = " +
                                        rahmen.getPriority() +
                                        " and R = " + rahmen.getReservierung()));
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }

          System.out.print(name + " wird zur StackingStation");
          System.out.println(" ??");
        }
        else { //Priorität der PDU kleiner oder gleich als aktuelle Priorität
          rahmen.reset();
          rahmen.setPriority(pRegister);
          rahmen.setReservierung(pdu.getPriority());
          netzwerk.getTimer().updateCurrentTime(tok /
              netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)
          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          if (rahmen.getPriority() != 0) {
            ausgabe.addElement(new String(name +
                " generates a new priotoken with P = " +
                rahmen.getPriority() + " and R = " +
                rahmen.getReservierung()));
          }
          else {
            ausgabe.addElement(new String(name +
                                          " generates a new token"));
          }
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }

          System.out.println(name + ": Reservierung = " + pdu.getPriority() +
                             " setzen");
        }
      }
      else { //Rahmenreservierung größer als PDU oder keine PDUs zu versenden
        if (rRegister > pRegister) { //Reservierung höher als aktuelle Priorität
          rahmen.reset();
          rahmen.setPriority(rRegister);
          stackingStation = true;
          Sx.push(new Integer(rRegister));
          System.out.println(name + ": Neuen Stack mit neuem Wert füllen = " +
                                rRegister);
          Sr.push(new Integer(pRegister));
          System.out.println(name + ": Alten Stack mit neuem Wert füllen = " +
                                pRegister);
          ausgabe.addElement(new String(name + " becomes a stacking station"));
          System.out.print(name + " wird zur StckingStation");
          netzwerk.getTimer().updateCurrentTime(tok /
              netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)

          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          ausgabe.addElement(new String(name +
                                        " generates a new priotoken with P = " +
                                        rRegister + " and R = " +
                                        rahmen.getReservierung()));
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }

          System.out.println(name + ": Prioritätstoken mit neuer Priorität " +
                             rRegister + " erzeugen");
        }
        else {
          rahmen.reset();
          rahmen.setPriority(pRegister);
          rahmen.setReservierung(rRegister);
          netzwerk.getTimer().updateCurrentTime(tok /
              netzwerk.getÜbertragGeschwind() ); //hier [ms], in [s] 1000000 & (float)
          if(!lösung)
          {
            BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
            bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
            zeitenListe.add(new Float(bd.floatValue()));
          }

          if (rahmen.getPriority() != 0) {

            ausgabe.addElement(new String(name +
                " generates a new priotoken with P = " +
                rahmen.getPriority() + " and R = " +
                rahmen.getReservierung()));
          }
          else {
            ausgabe.addElement(new String(name +
                                          " generates a new token"));
          }
          if(lösung & !theorie)
            if(indexZeit < zeitenListe.size())
            {
              ausgabe.add(new String(name+" sends at t = "+((Float)zeitenListe.get(indexZeit)).floatValue()));
              indexZeit++;
            }

          System.out.println(name + ": Prioritätstoken zurückschicken mit P = " +
                             pRegister + " und R = " + rRegister);
        }
      }
    }
    else { //kein eigener Frame
      if (!PDUqueue.isEmpty() &&
          ( (PDU) PDUqueue.getFirst()).getPriority() >
          rahmen.getReservierung()) {
        rahmen.setReservierung( ( (PDU) PDUqueue.getFirst()).getPriority());
        ausgabe.addElement(new String(name + " sets the reservation bits R = " +
                                      rahmen.getReservierung()));
        System.out.println(name + ": Reservierung = " + rahmen.getReservierung() +
                           " vornehmen im Rahmen ");
      }
      if (rahmen.getPDU().getDestinationStation().getName().equals(getName())) {
        rahmen.setAddressRecognizedBit(true);
        rahmen.setFrameCopiedBit(true);
        ausgabe.addElement(new String(name + " copies and repeats the frame"));
        System.out.println(name + ": Rahmen kopieren");
      }
      else {
        if (netzwerk.getDifficulty() < 6) {
          ausgabe.addElement(new String(name + " repeats the frame"));
        }
      }
    }
  }

  public void pduNeuInitialisieren() {
    PDUqueue.clear();
    if (!PDUqueueAbgearbeitet.isEmpty()) {
      int j = PDUqueueAbgearbeitet.size();
      if (fehler) {
        ( (PDU) PDUqueueAbgearbeitet.get(zirkulierendePDU)).setFehler(true);
      }
      if (!netzwerk.getGlobalPDUqueue().isEmpty()) {
        /* bei erneutem Start: alle evtl. nicht versendete PDUs entfernen*/
        int l = netzwerk.getGlobalPDUqueue().size();
        for (int i = 0; i < l; i++) {
          if ( ( (PDU) netzwerk.getGlobalPDUqueue().get(i)).getSenderStation().
              getName().equals(name)) {
            netzwerk.getGlobalPDUqueue().remove(i);
            l--;
            i--;
          }
        }
      }
      for (int i = 0; i < j; i++) {
        netzwerk.addPDU( (PDU) PDUqueueAbgearbeitet.get(i));
        PDUqueue.add(PDUqueueAbgearbeitet.get(i));
      }
    }
    setLoesung(true);
    indexZeit = 0;
    fertig.set(index, new Boolean(false));
  }

  public void setZirkulierendePDUIndex(int zirkulierendePDU) {
    this.zirkulierendePDU = zirkulierendePDU;
  }

  public void setFehler(boolean fehler) {
    this.fehler = fehler;
  }

  public void setTheorie(boolean theorie) {
    this.theorie = theorie;
  }

  public void setLoesung(boolean loesung) {
    this.lösung = loesung;
  }

  public int compareTo(Object object) {
    Station station = (Station) object;
    char[] vergleichsName = station.getName().toCharArray();
    char[] Name = name.toCharArray();
    if (vergleichsName[0] == Name[0]) {
      return 0;
    }
    else {
      if (vergleichsName[0] < Name[0]) {
        return 1;
      }
      else {
        return -1;
      }
    }

  }
}