import java.util.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description:
 * Diese Klasse gibt die Aufgabestellung und die Auswahlmöglichkeiten zum Beantworten
 * der Aufgabe, überprüft die Eingabe des Anwenders auf Richtigkeit und sendet die
 * Daten an den Server
 * </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class TheorieAufgaben {
  int difficulty = 0;
  Netzwerk netzwerk;
  int n = 4;
  Vector eingabeCheck = new Vector();
  Vector eingabe = new Vector();
  MainFrame mainFrame;
  String[] aufgabenStellung = {
      "Enter the occuring steps,",
//      "Zeigen Sie die einzelnen Schritte auf",
      " beginning with the arrivial of the token at the station ",
//      " von dem Moment an, als das Token bei der Station ",
      " until all stations have send all their data",
//      " ankommt, bis alle Stationen alle ihre Daten versendet haben",
      " and a new free token is generated.",
//      " und ein freies Token wieder erzeugt wird ",
      " Transmission of packages between stations is done clockwise.",
      ""
  };
  int valuation = 0;
  String[] grund = {
      "generates a new token",
      "transmits its own frame",
      "receives its own frame",
      "repeats the frame",
      "repeats the token",
      "copies and repeats the frame",
      "receives a token"};

  String[] monitoring = {
      "generates a new token",
      "sets the monitor bit",
      "transmits its own frame",
      "receives its own frame",
      "copies and repeats the frame",
      "transmits a ring purge frame",
      "strips the ring purge frame from the ring",
      "receives a frame with M = 1"
  };

  String[] priorisierung = {
      "generates a new token",
      "generates a new priotoken",
      "receives a priotoken",
      "receives its own frame",
      "transmits its own frame",
      "becomes a stacking station",
      "discontinues its role as a stacking station",
      "continues its role as a stacking station",
      "sets the reservation bits",
      "copies and repeats the frame",
      "sets the monitor bit",
      "receives a frame with M = 1",
      "transmits a ring purge frame",
      "strips the ring purge frame from the ring"
  };

  public TheorieAufgaben(MainFrame mainFrame, Netzwerk netzwerk, int difficulty) {
    this.mainFrame = mainFrame;
    this.netzwerk = netzwerk;
    this.difficulty = difficulty;
  }

  public String[] getTheorieText(int difficulty) {
    if (difficulty <= 5) {
      return grund;
    }
    else {
      if (difficulty >= 6 && difficulty <= 10) {
        return monitoring;
      }
      else {
        if (difficulty >= 11) {
          return priorisierung;
        }
        else {
          return null;
        }
      }
    }
  }

  public String[] getAufgabenStellung() {
    Station pos = (Station) netzwerk.getRahmen().getPosition();
    aufgabenStellung[1] = aufgabenStellung[1].concat(pos.getName());
    System.out.println(aufgabenStellung[1]);
    if (difficulty > 5) {
      for (int i = 0; i < netzwerk.getGlobalPDUqueue().size(); i++) {
        if ( ( (PDU) netzwerk.getGlobalPDUqueue().get(i)).getFehler()) {

          String stringfehlerPDU =
              " The red marked PDU will not be striped by station "
              //"  Die rot-markierte PDU wird von der Sendestation "
              +
              ( (PDU) netzwerk.getGlobalPDUqueue().get(i)).getSenderStation().
              getName()
              + " from the ring. This is the error frame. The retransmission of the PDU is succesfull.";
          //" nicht vom Ring genommen.";
          aufgabenStellung[5] = aufgabenStellung[5].concat(" " +
              stringfehlerPDU);
        }
      }
    }
    return aufgabenStellung;
  }

  /*
   * Diese Methode überprüft die Eingabe des Users auf Richtigkeit.
   * Zuerst wird die Lösung und die Eingabe des Users gruppiert,
   * dann werden die Eingabe und die Lösung um fehlende (leere) Gruppen ergänzt.
   * Die Gruppen werden jeweils miteinander vergliechen und die richtigen sowie
   * die falschen Einträge werden als solche markiert.
   */
  public Vector check() {
    int index = 0; //aktionen der Eingabe einzeln
    ArrayList aktionenNachGruppen = new ArrayList(); //Liste der Lösungsgruppen
    Vector aktionen = netzwerk.getAktionen(); //Liste aller Lösungsschritte
    Iterator it = aktionen.iterator();
    AktionenGruppe loesgruppe = new AktionenGruppe(); //Gruppe zusammenhängender Aktionen
    aktionenNachGruppen.add(loesgruppe);
    System.out.println("Loesung nach Gruppen sortieren");
    while (it.hasNext()) {
      String aktion = (String) it.next();
      if (!loesgruppe.initialisiereAktionen(aktion, true)) {
        loesgruppe = new AktionenGruppe();
        aktionenNachGruppen.add(loesgruppe);
        loesgruppe.initialisiereAktionen(aktion, true);
      }

    }
    System.out.println("Länge der LösungsListe gruppiert: " +
                       aktionenNachGruppen.size());

    System.out.println("Eingabe nach Gruppen sortieren");
    ArrayList eingabeNachGruppen = new ArrayList(); //Liste der Eingabegruppen
    Iterator eIt = eingabe.iterator();
    AktionenGruppe gruppe = new AktionenGruppe(); //Gruppe zusammenhängender Aktionen
    eingabeNachGruppen.add(gruppe);
    while (eIt.hasNext()) {
      String aktion = (String) eIt.next();
      if (!gruppe.initialisiereAktionen(aktion, false)) {
        gruppe = new AktionenGruppe();
        eingabeNachGruppen.add(gruppe);
        gruppe.initialisiereAktionen(aktion, false);
      }
    }
    System.out.println("Länge der EingabeListe gruppiert: " +
                       eingabeNachGruppen.size());

    if (! ( (AktionenGruppe) eingabeNachGruppen.get(0)).aktionenSt.isEmpty()) {
      //wenn die Eingabe nicht leer ist
      for (int i = 0;
           i < (aktionenNachGruppen.size() <= eingabeNachGruppen.size()
                ? aktionenNachGruppen.size() : eingabeNachGruppen.size()); i++) {
        //gehe kleinere der beiden Gruppen durch
        int size = (aktionenNachGruppen.size() <= eingabeNachGruppen.size()
                ? aktionenNachGruppen.size() : eingabeNachGruppen.size());
        AktionenGruppe eingabeGruppe = (AktionenGruppe) eingabeNachGruppen.get(
            i);
        AktionenGruppe loesungsGruppe = (AktionenGruppe) aktionenNachGruppen.
            get(i);

        if (!eingabeGruppe.station.equals(loesungsGruppe.station)) {
          //wenn die Stationennamen der Eingabegruppe und Lösungsgruppe nicht übereinstimmen
          if(i == 0 || i == size-1) //erste und letzte Gruppe
          {
            //Leere Gruppe in die Eingabe des Users einfügen
            AktionenGruppe neu = new AktionenGruppe();
            neu.leereGruppeErzeugen(loesungsGruppe.station);
            eingabeNachGruppen.add(i, neu);
          }
          else
          {
            AktionenGruppe eingabeGruppeVor = (AktionenGruppe) eingabeNachGruppen.get(i-1);
            AktionenGruppe eingabeGruppeNach = (AktionenGruppe) eingabeNachGruppen.get(i+1);
            AktionenGruppe loesungsGruppeVor = (AktionenGruppe) aktionenNachGruppen.get(i-1);
            if(eingabeGruppeVor.station.equals(loesungsGruppeVor.station)
               && eingabeGruppeNach.station.equals(loesungsGruppe.station))
            {
              //Leere Gruppe in die Lösung eintragen
              AktionenGruppe neu = new AktionenGruppe();
              neu.leereGruppeErzeugen(eingabeGruppe.station);
              aktionenNachGruppen.add(i, neu);
            }
            else
            {
              //Leere Gruppe in die Eingabe des Users einfügen
              AktionenGruppe neu = new AktionenGruppe();
              neu.leereGruppeErzeugen(loesungsGruppe.station);
              eingabeNachGruppen.add(i, neu);
            }
          }
        }
      }
    }
    for (int i = 0; i < (aktionenNachGruppen.size() <= eingabeNachGruppen.size()
                         ? aktionenNachGruppen.size() : eingabeNachGruppen.size());
         i++) {
      AktionenGruppe eingabe = (AktionenGruppe) eingabeNachGruppen.get(i);
      AktionenGruppe loesung = (AktionenGruppe) aktionenNachGruppen.get(i);
      Vector eingabeSt = eingabe.aktionenSt;
      int vergleich = 0;
      String ein = "";
      for (int j = 0; j < eingabeSt.size(); j++) {
        ein = (String) eingabeSt.get(j);
        try {
          vergleich = loesung.checkEingabeGruppe(ein, j);
          eingabe.loesungRichtig.set(j, new Boolean(true));
          eingabe.vergleich.set(j, new Integer(vergleich));
          valuation++;
          index++;
        }
        catch (theorieEingabeException tee) {
          vergleich = 2;
          eingabe.loesungRichtig.set(j, new Boolean(false));
          eingabe.vergleich.set(j, new Integer(vergleich));
          valuation--;
        }
        finally {
          System.out.println("Bewertet: " + ein + " " + vergleich);
        }
      }
      int x = 0;
      int j = 0;
      for (; j < (loesung.loesungRichtig.size() >= eingabeSt.size() ?
                  loesung.loesungRichtig.size() : eingabeSt.size()); ) {
        if (j < loesung.loesungRichtig.size()) {
          if ( ( (Integer) loesung.indexEingabeBeiTrue.get(j)).intValue() ==
              100) {
            eingabeCheck.add(new theorieZeile(
                (String) loesung.aktionenSt.get(j),
                ( (Integer) loesung.vergleich.get(j)).intValue()
                ));
          }
        }
        if (x < eingabeSt.size()) {
          eingabeCheck.add(new theorieZeile(
              (String) eingabeSt.get(x),
              ( (Integer) eingabe.vergleich.get(x)).intValue()));
          x++;
        }
        j++;

      }
    }
    int size = eingabeNachGruppen.size();
    if (size < aktionenNachGruppen.size()) {
      for (int i = size; i < aktionenNachGruppen.size(); i++) {
        AktionenGruppe loes = (AktionenGruppe) aktionenNachGruppen.get(i);
        for (int j = 0; j < loes.aktionenSt.size(); j++) {
          eingabeCheck.add(new theorieZeile(
              (String) loes.aktionenSt.get(j),
              ( (Integer) loes.vergleich.get(j)).intValue()
              ));
        }
      }
    }

    if(size > aktionenNachGruppen.size())
    {
      for (int i = aktionenNachGruppen.size(); i < size; i++)
      {
        AktionenGruppe eing = (AktionenGruppe) eingabeNachGruppen.get(i);
        for(int j = 0; j < eing.aktionenSt.size(); j++)
        {
          eingabeCheck.add(new theorieZeile(
              (String) eing.aktionenSt.get(j), 2));
        }
      }
    }
    valuation = (netzwerk.getAktionen().size() > index ? -1 : 1);
    return eingabeCheck;
  }

  public int getValuation() {
    return valuation;
  }

  public void addEingabe(String eingabeZeile) {
    eingabe.add(eingabeZeile);
  }

  public void addEingabe(String eingabeZeile, int i) {
    eingabe.add(i, eingabeZeile);
  }

  public void removeEingabe(int i)
  {
    eingabe.remove(i);
  }

  public String datenSenden(java.util.List SendParameter) {
    for (int i = 0; i < SendParameter.size(); i++) {
      System.out.println(SendParameter.get(i));
    }
    results k1 = new results();
    k1.command = "ergeing";
    k1.appletid = (String) SendParameter.get(4);
    k1.id = (String) SendParameter.get(0);
    k1.password = (String) SendParameter.get(1);
    k1.difficulty = (String) SendParameter.get(2);
    k1.valuation = "" + valuation;

    k1.time = (String) SendParameter.get(3);
    k1.status();
    k1.destip = mainFrame.tokenRingTrainer.getDocumentBase().getHost();
    k1.destport = 3200;
    k1.send();
    k1.status();
    return k1.ok;

  }
}