import java.util.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description:
 * Nach dem Erzeugen der Aufgabe, wird das Szenario einmal durch gespielt, ohne
 * dass eine Animation gestartet wird. Diese Klasse reguliert den Ablauf, indem
 * sie die entsprechenden Methoden der Stationen und Verbindungen aufruft und
 * den Ablauf stoppt, wenn alle Stationen mit der Übertragung fertig sind.
 * </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
/*
 */
public class TokenRingManager
    extends Thread {

  Netzwerk netzwerk;
  Rahmen rahmen;

  public TokenRingManager(Netzwerk netzwerk) {
    this.netzwerk = netzwerk;
    rahmen = netzwerk.getRahmen();
  }

  public void run() {
    LinkedList stationenListe = netzwerk.getStationenListe();

    Station station = (Station) rahmen.getPosition();

    LinkedList stationenListeHilf = new LinkedList();
    for (int i = 0; i < stationenListe.size(); i++) {
      stationenListeHilf.add(station);
      station = station.getSuccessor();
    }
    int sendeCount = 0;
    while (!netzwerk.getGlobalPDUqueue().isEmpty() ||
           netzwerk.getRahmen().getPriority() != 0 ||
           !netzwerk.getRahmen().getTokenBit()) {
      //solange noch PDUs zu vesenden da sind, die Priorität des Tokens nicht 0
      //ist und das umkreisende Rahmen kein Token ist, wird der Ablauf fortgesetzt
      //
      for (int i = 0; i < stationenListe.size(); i++) {
        Station station1 = (Station) stationenListeHilf.get(i);
        if (!netzwerk.getGlobalPDUqueue().isEmpty() ||
            netzwerk.getRahmen().getPriority() != 0 ||
            !netzwerk.getRahmen().getTokenBit())
        {
          Vector ausgabe = station1.receiveData(rahmen);
          for (int j = 0; j < ausgabe.size(); j++) {
            netzwerk.setAktionen( (String) ausgabe.get(j));
          }
          station1.getDownstreamConnection().delieverFrame();
        }
        sendeCount++;
      }
    }

    System.out.println("TKManager: sendeCount = " + sendeCount);
    System.out.println("Zeit: " + netzwerk.getTimer().getCurrentTime());
  }
}