
import javax.swing.*;
import java.awt.*;
import java.util.*;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class Utilities {

  public static final int MAX_CHAR_PER_LINE = 140;

  public Utilities() {
  }

  public static void centerComponent(Component c) {
    //Center the Component

    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize(
        );
    Dimension frameSize = c.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    c.setLocation( (screenSize.width - frameSize.width) / 2,
                  (screenSize.height - frameSize.height) / 2);
  }

  public static JPanel createMultilineLabel(String text) {
    return createMultilineLabel(text, Color.black);
  }

  public static JPanel createMultilineLabel(String text, Color color)
  {
    return createMultilineLabel(text, color, MAX_CHAR_PER_LINE);
  }

/*  public static JPanel createMultilineLabel(String text, Color color, int col) {
    return createMultilineLabel(text, color, col, Color.WHITE);
  }
*/
  public static JPanel createMultilineLabel(String text, Color color, int col) {

    //create a panel that has multiple labels that are all not longer
    //than MAX_CHAR_PER_LINE caracters
    JPanel pTmp = new JPanel();
    pTmp.setBorder(BorderFactory.createEmptyBorder(2, 5, 2, 5));
    LinkedList labels = new LinkedList();
    StringTokenizer token = new StringTokenizer(text);
    String tmp = "";
    String line = token.hasMoreTokens() ? token.nextToken() : "";
    while (token.hasMoreTokens()) {
      tmp = token.nextToken();
      //only add next word (and a space) if current
      //line will not exceed MAX_CHAR_PER_LINE
      if ( (line.length() + tmp.length()) < col) {
        //build up line
        line += " " + tmp;
      }
      else {
        //add line
        JLabel lTmp = new JLabel(line);
        lTmp.setHorizontalAlignment(JLabel.CENTER);
        lTmp.setForeground(color);
        line = tmp;
        labels.add(lTmp);
      }
    }
    //add last line
    JLabel lTmp = new JLabel(line);
    //lTmp.setHorizontalAlignment(JLabel.CENTER);
    lTmp.setForeground(color);
    line = tmp;
    labels.add(lTmp);
    //set panel Layout
    pTmp.setLayout(new GridLayout(labels.size(), 1));
    //add labels to panel
    while (!labels.isEmpty()) {
      pTmp.add( (JLabel) labels.removeFirst());
    }
    //@@@
    pTmp.setBackground(Color.LIGHT_GRAY);
    return pTmp;
  }

}