
import java.util.List;
import java.math.BigDecimal;

/**
 * <p>Title: TokenRingTrainer</p>
 * <p>Description: Rechenaufgaben, bei denen Zeit berechnet werden muss</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class ZeitRechenAufgaben implements RechenAufgaben{
  boolean t = true, r = false;
  Netzwerk netzwerk;
  float loesung = 0.0f;
  int valuation = 0;
  MainFrame mainFrame;
  boolean[] aufg_Art = {
      t, r, r, t, r, t, r, t, r, t, r, r, t, r, t, r, t, r, t, r, t, r, t, r, t,
      r};

  public static String[] aufgabenStellung = {
      "How long does it take",
      //"Wie lange dauert es, ",
      " untill all stations have send their data",
      //"bis alle Stationen ihre Daten versendet haben",
      " and a new free token is generated",
      //" und ein normales Token wieder erzeugt wird, ",
      " beginning when the token arrives at the station",
      //" ab dem Zeitpunkt, als das Token bei der Station",
      "?",
      " Transmission of packages between stations is done clockwise.",
      " The frame size is equivalent to 10 ms and a frame contains one PDU.",
      " The 1-Bit-Delay is to be ignored."
  };
      //" ankommt?"};
      public static String[] aufgabenStellungFehler = {
          "How long does it take",
          //"Wie lange dauert es, ",
          " untill all stations have send their data",
          //"bis alle Stationen ihre Daten versendet haben",
          " and a new free token is generated",
          //" und ein normales Token wieder erzeugt wird, ",
          " beginning when the token arrives at the station",
          //" ab dem Zeitpunkt, als das Token bei der Station",
          "?",
          " Transmission of packages between stations is done clockwise.",
          " The frame size is equivalent to 10 ms and a frame contains one PDU.",
          " The 1-Bit-Delay is to be ignored. The ring purge frame size is 100 Byte."
      };
          //" ankommt?"};

  public ZeitRechenAufgaben(MainFrame mainFrame, Netzwerk netzwerk) {
    this.mainFrame = mainFrame;
    this.netzwerk = netzwerk;
  }

  public String[] getAufgabenstellung() {
    Station station;
    for(int i = 0; i < netzwerk.getSendeStationenListe().size(); i++)
    {
      station = (Station) netzwerk.getSendeStationenListe().get(i);
      for(int j = 0; j < station.getPDUQueue().size(); j++)
      {
        if(((PDU) station.getPDUQueue().get(j)).getFehler())
          return aufgabenStellungFehler;
      }
    }
    return aufgabenStellung;
  }

  public boolean check(String eingabe) throws EingabeException{
    eingabe = eingabe.replace(',', '.');
    String ergebnis = new String();
    ergebnis = ergebnis.valueOf(getSolution());
    int trennPunktIndex = ergebnis.indexOf(".");
    String vorkomma = ergebnis.substring(0, trennPunktIndex);
    String nachkomma = ergebnis.substring(trennPunktIndex +1, ergebnis.length());

    int eingabeTrennPunktIndex = eingabe.indexOf(".");
    if(eingabeTrennPunktIndex < 0)
      throw new EingabeException("Please enter the value with the precision of 1/100");

    String eingabeVorkomma = eingabe.substring(0, eingabeTrennPunktIndex);
    String eingabeNachkomma = eingabe.substring(eingabeTrennPunktIndex +1, eingabe.length());
    if(eingabeNachkomma.length() < 2)
      throw new EingabeException("Please enter the value with the precision of 1/100");

    if (eingabeVorkomma.equals(vorkomma)) {
      if(eingabeNachkomma.substring(0, 2).equals(nachkomma.substring(0, 2)))
      {
        valuation = 1;
        return true;
      }
      else
      {
        valuation = -1;
        throw new EingabeException("Sorry, incorrect answer");
      }
    }
    else {
      valuation = -1;
      throw new EingabeException("Sorry, incorrect answer");
    }

  }
  public String datenSenden(java.util.List SendParameter)
  {
    for (int i=0; i<SendParameter.size(); i++)
    {
      System.out.println(SendParameter.get(i));
    }
    results k1 = new results();
    k1.command ="ergeing";
    k1.appletid =(String)SendParameter.get(4);
    k1.id =(String)SendParameter.get(0);
    k1.password=(String)SendParameter.get(1);
    k1.difficulty=(String) SendParameter.get(2);
    k1.valuation = ""+valuation;

    k1.time =(String)SendParameter.get(3);
    k1.status();

    k1.destip = mainFrame.tokenRingTrainer.getDocumentBase().getHost();
    k1.destport = 3200;
    k1.send();
    k1.status();
    return k1.ok;

  }
  public float getSolution()
  {
    setSolution();
    return loesung;
  }
  void setSolution()
  {
    float x = ((Verbindung)netzwerk.getVerbindungenListe().get(0)).getSize();
    x /= 200000; //200000000
//    loesung = netzwerk.getTimer().getCurrentTime() - x; //ohne die letzte Strecke
    BigDecimal bd = new BigDecimal(netzwerk.getTimer().getCurrentTime());
    bd = bd.setScale(4, BigDecimal.ROUND_HALF_EVEN);
    loesung = bd.floatValue() - x; //ohne die letzte Strecke
  }
  public int getValuation()
  {
    return valuation;
  }
}