
package viror.teach.anim;

/** This interface represents a class that will animate our
  Display. The standard implentation is SimpleAnimList. In fact
  it is generally desireable to have the two functionalities
  operating closely together. */
public interface AnimCycle extends Runnable
{

/** Resumes an animation that was interrupted by a call of
  suspend */
void resumeAnim();

/** Halts an animation until it is started again with
  resume. */
void suspendAnim();

/** Sets the Frame rate. Since we can only wait full miliseconds
  between frames the actual framerate might differ slightly from this
  one. */
void setFrameRate(int i);

/** Returns the actual frame rate, not necessarily the one that was
  set by setFrameRate (see above). */
int getFrameRate();

}
