
//Title         Viror.teach.anim library
//Version       1.0
//Copyright     Copyright (c) Ralf Gitzel
//Author        Ralf Gitzel
//Company:      Wifo III
//Description:  

package viror.teach.anim;

import java.beans.*;

public class AnimDisplayBeanInfo extends SimpleBeanInfo
{
  Class beanClass = AnimDisplay.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public AnimDisplayBeanInfo()
  {
  }

  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _grid = new PropertyDescriptor("grid", beanClass, "getGrid", "setGrid");
      _grid.setDisplayName("Grid");
      _grid.setShortDescription("The internal coordinate system");
      PropertyDescriptor _list = new PropertyDescriptor("list", beanClass, null, "setList");
      _list.setDisplayName("List");
      _list.setShortDescription("The AnimList that holds the objects to be displayed");
      PropertyDescriptor _screenUsage = new PropertyDescriptor("screenUsage", beanClass, "getScreenUsage", "setScreenUsage");
      _screenUsage.setDisplayName("Screen Usage");
      _screenUsage.setShortDescription("The anmount of the screen in percent to be used");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _grid,
	      _list,
	      _screenUsage};
      return pds;
    


}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}