
package viror.teach.anim;

/** A progress indicator is a GUI component that shows
  the progress of some activity. This can be done by
  highlighting code lines, by sliding window pies or
  other means. A progress indicator can have several
  channels that advance differently, e.g. a sliding
  window has an upper and lower bound which would be
  two separate channels. */
public interface ProgressIndicator
{

/** Advance progress indicator channel i by one step. */
void advance(int i) throws ArrayIndexOutOfBoundsException;

/** Undo last progress step for indicator channel i. */
void stepBack(int i) throws ArrayIndexOutOfBoundsException;

/** A hard jump for resets etc. Will set the displayed progress to the
 *  given absolute postion. */
void setPosition(int i, int pos);

/** Return the current progress position. */
int getPosition(int i);

}
