

package viror.teach.anim;

/** This interface indicates that the implementing class changes its
  values in a from that could be considered a progress. Examples are
  programms moving through code, sliding windows (where the upper and the
  lower value are each a progressing state). */
public interface Progressive
{

void addProgressIndicator(ProgressIndicator i);

void removeProgressIndicator(ProgressIndicator i);

/** Indicates that there was a progress that should change an
  indicator of the ProgressIndicator.
  @param stateAffected The value which was changed. Some progresses
  do not have a single value but rather several that advance seperately.
  @param forward If true advance should be called otherwise stepBack.
  @param steps The number of steps to execute in the given direction. */
void fireProgress(int stateAffected, boolean forward);

/** This version of fireProgress allows to jump directly to certain lines */
void fireProgress(int stateAffected, int line);

}

