
//Title         Viror.teach.anim library
//Version       1.0
//Copyright     Copyright (c) Ralf Gitzel
//Author        Ralf Gitzel
//Company:      Wifo III
//Description:  

package viror.teach.anim;

import java.beans.*;

public class SimpleAnimListBeanInfo extends SimpleBeanInfo
{
  Class beanClass = SimpleAnimList.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public SimpleAnimListBeanInfo()
  {
  }
  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _frameRate = new PropertyDescriptor("frameRate", beanClass, "getFrameRate", "setFrameRate");
      _frameRate.setDisplayName("Frame Rate");
      _frameRate.setShortDescription("The animation speed and smoothness");
      PropertyDescriptor _mode = new PropertyDescriptor("mode", beanClass, "getMode", "setMode");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _frameRate,
	      _mode};
      return pds;
    

}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }
  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}