
//Titel:Viror Animationsbibliothek
//Version:
//Copyright:Copyright (c) 1998
//Autor:Ralf Gitzel
//Firma:
//Beschreibung:Diese Sammlung von JavaBeans liefert eine grundlegende Bibliotek
//zur Erstellung von TeachWare, welche Animationen verwendet.

package viror.teach.anim;

import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class TestFrame extends Frame
{

  private TestApp app;

  //Frame konstruieren
  BorderLayout borderLayout1 = new BorderLayout();

  public TestFrame(TestApp t)
  {
    app = t;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

  }
//Initialisierung der Komponente

  private void jbInit() throws Exception
  {
    Dimension[] way = new Dimension[5];
    way[0] = new Dimension(10,10);
    way[1] = new Dimension(50,50);
    way[2] = new Dimension(50,100);
    way[3] = new Dimension(35,50);
    way[4] = new Dimension(10,60);
    // stolen from the same source as the code for getURL.
    Image cof = app.getImage(app.getURL("RedMachine.gif"));
    Image sel = app.getImage(app.getURL("RedSelected.gif"));
    Image hpipe = app.getImage(app.getURL("Factory.gif"));
    MediaTracker m = new MediaTracker(app);
    m.addImage(cof, 0);
    m.addImage(sel, 0);
    m.addImage(hpipe, 0);
    try { m.waitForAll(); } catch (Exception e) {}
    final SimpleAnimList a = new SimpleAnimList();
    AnimActor[] tester = new AnimActor[3];
    AnimStatic t1 = new AnimStatic(cof, sel, true, 30, 50);
    AnimStatic t2 = new AnimStatic(cof, true, 75, 75);
    AnimStatic t3 = new AnimStatic(hpipe, true, 80, 50);
    t3.setPeer(new PrimitiveRep(PrimitiveRep.CIRCLE, 20));
    //t2.setPeer(new PolygonRep(way, true));
    AnimPath test2  = new AnimPath();
    // AnimPath pipe = new AnimPath(hpipe, hpipe);
    test2.setStart(t1);
    test2.setStartTangent(0,30);
    test2.setEnd(t2);
    test2.setEndTangent(0,-50);
    test2.generateRepresentation();
    //pipe.setStart(t1);
    //pipe.setEnd(t3);
    for (int i = 0; i < 2 ; i++)
      {
	tester[i] = new AnimActor();
	tester[i].setCompletion(10*i/2);
	test2.addActor(tester[i]);
      }
    Dimension[] line = new Dimension[4];
    for(int i=0; i < 4; i++) line[i] = new Dimension();
    line[0].width = 50;  line[0].height = 50;
    line[1].width = 100; line[1].height = 50;
    line[2].width = 50;  line[2].height = 100;
    line[3].width = 50;  line[3].height = 75;
    AnimStatic poly = new AnimStatic(line, true, true);
    this.setLayout(borderLayout1);
    this.setTitle("TestApp fuer AnimBibliothek - nicht verwenden!");
    final AnimDisplay dis = new AnimDisplay(AnimDisplay.SQUARE, a);
    dis.setScreenUsage(.3);
    this.add(dis, BorderLayout.CENTER);
    StandardButtons b = new StandardButtons();
    b.setAList(a);
    b.setAnimControl(a);
    b.addInsertButton("Insert Router", t3);
    b.addInsertButton("Insert Huge Polygon", poly);
    this.add(b, BorderLayout.SOUTH);
    this.pack();
    this.addKeyListener(a);
    this.addFocusListener(new FocusAdapter()
			  {
			  public void focusGained(FocusEvent e)
			    {
			    System.out.println("Focus gained!");
			    }
			  });
    this.addWindowListener(new WindowAdapter()
			   {
			   public void windowActivated(WindowEvent e)
			     {
			     System.out.println("Window activated!");
			     }
			   public void windowDeactivated(WindowEvent e)
			     {
			     System.out.println("Window deactivated!");
			     }
			   });
    a.addElement(1, t1);
    a.addElement(1, t2);
    a.addElement(1, t3);
    for(int i=0; i<2;i++) a.addElement(2, tester[i]);
    a.addElement(0, test2);
    //a.addElement(0, pipe);
    a.start();
  }
}









