
//Title         Viror.teach.anim.net
//Version       1.0
//Copyright     Copyright (c) Ralf Gitzel
//Author        Ralf Gitzel
//Company:      Wifo III
//Description:  

package viror.teach.anim.net;

import java.beans.*;

public class AbstractRouterBeanInfo extends SimpleBeanInfo
{
  Class beanClass = AbstractRouter.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public AbstractRouterBeanInfo()
  {
  }

  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _description = new PropertyDescriptor("description", beanClass, "getDescription", "setDescription");
      _description.setDisplayName("Description");
      PropertyDescriptor _name = new PropertyDescriptor("name", beanClass, "getName", "setName");
      _name.setDisplayName("Name");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _description,
	      _name};
      return pds;
    

}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}