

package viror.teach.anim.net;

import viror.teach.anim.*;
import javax.swing.*;
import java.awt.event.*;
import java.beans.*;

/** This class allows the editing of Payloads in a Package. Note that there
 * are slight variations from the other Customizers since this one is never
 * invoked directly but rather only by PackageCustomizer.
 */
public class BasicPayloadCustomizer extends JPanel implements PayloadCustomizer
{

PropertyChangeSupport Listeners;

private boolean Editable;
private JTextField InputField;

/** Undo value */
private String UText;

/** The object that is customized with this object */
private BasicPayload Data;

/** The Text Field to enter the payload line */

public BasicPayloadCustomizer()
  {
  this(true);
  }

public BasicPayloadCustomizer(boolean edit)
  {
  super();
  Editable = edit;
  InputField = new JTextField(10);
  if (edit) add(InputField);
  }

public void undo()
  {
  Data.setData(UText);
  }

public void setObject(Object o)
  {
  Data = (BasicPayload) o;
  UText = Data.getData();
  InputField.setEditable(true);
  InputField.setText(UText);
  InputField.setEditable(Editable);

  }


public BasicPayload spawnObject()
  {
  BasicPayload ret = new BasicPayload();
  ret.setData(InputField.getText());
  return ret;
  }

public void addPropertyChangeListener(PropertyChangeListener l)
  {
  Listeners.addPropertyChangeListener(l);
  }

public void removePropertyChangeListener(PropertyChangeListener l)
  {
  Listeners.removePropertyChangeListener(l);
  }

public void setEditable(boolean newEditable)
  {
  Editable = newEditable;
  InputField.setEditable(Editable);
  }

public boolean isEditable()
  {
  return Editable;
  }

}