
//Title         Viror.teach.anim.net
//Version       1.0
//Copyright     Copyright (c) Ralf Gitzel
//Author        Ralf Gitzel
//Company:      Wifo III
//Description:

package viror.teach.anim.net;

import java.beans.*;

public class HighlightTextBeanInfo extends SimpleBeanInfo
{
  Class beanClass = HighlightText.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public HighlightTextBeanInfo()
  {
  }

  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _lines = new PropertyDescriptor("lines", beanClass, null, "setLines");
      _lines.setDisplayName("Text");
      _lines.setShortDescription("The text to be displayed in each line");
      PropertyDescriptor _numberOfVisibleCharacters = new PropertyDescriptor("numberOfVisibleCharacters", beanClass, "getNumberOfVisibleCharacters", "setNumberOfVisibleCharacters");
      _numberOfVisibleCharacters.setDisplayName("Columns");
      _numberOfVisibleCharacters.setShortDescription("The number of visible Characters per Line");
      PropertyDescriptor _numberOfVisibleLines = new PropertyDescriptor("numberOfVisibleLines", beanClass, "getNumberOfVisibleLines", "setNumberOfVisibleLines");
      _numberOfVisibleLines.setDisplayName("Lines");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _lines,
	      _numberOfVisibleCharacters,
	      _numberOfVisibleLines};
      return pds;



}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }

  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}