
/**
 * Title:        Viror.teach.anim.net<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Ralf Gitzel<p>
 * Company:      Wifo III<p>
 * @author Ralf Gitzel
 * @version 1.0
 */
package viror.teach.anim.net;

/** Objects of this class have added functionality that allows their
 *  content to be compared to the name of a SoftwareComponent or
 *  Router. This can be used as some kind of routing information if
 *  the SimpleParseHandler does not seem good enough. Also the
 *  SoftwareHandler uses this Payload to find the proper software
 *  component to use for handling the package.
 */
public class IDPayload extends BasicPayload
{

public IDPayload(String id)
  {
  this.setData(id);
  }

public void setID(String id)
  {
  setData(id);
  }

public String getID()
  {
  return getData();
  }

/** returns true, if the name of the component is equal to the data of this
 *  payload. */
public boolean isTarget(SoftwareComponent s)
  {
  if (getData().equals(s.getName())) return true;
  return false;
  }
}