
package viror.teach.anim.net;

import java.lang.reflect.*;


/** A couple of utility functions that help with introspection */
public class IntrospectionHelper
{

/** This function returns an array of all methods that start with x.
  The array does not contain the method objects, rather the names, minus
  the prefix X. Only public methods are considered.
  @param c The class whose methods are to be regarded
  @param x The prefix of the method name */
public static String[] getXMethods(Class c, String x)
  {
  Method[] m = c.getMethods();
  int count = 0;
  String[] tmp  = new String[m.length];
  for(int i=0; i < m.length; i++)
    {
    if(m[i].getName().startsWith(x))
      {
      tmp[count] = m[i].getName().substring(x.length());
      count++;
      }
    }
  String[] ret = new String[count];
  for (int i=0; i < count; i++)
    {
    ret[i] = tmp[i];
    }
  return ret;
  }

/** This function returns an array of all properties that start with x.
  The array does not contain the attibute objects, rather the names, minus
  the prefix X. Only public methods are considered.
  @param c The class whose methods are to be regarded
  @param x The prefix of the method name */
public static String[] getXField(Class c, String x)
  {
  Field[] m = c.getFields();
  int count = 0;
  String[] tmp  = new String[m.length];
  for(int i=0; i < m.length; i++)
    {
    if(m[i].getName().startsWith(x))
      {
      tmp[count] = m[i].getName().substring(x.length());
      count++;
      }
    }
  String[] ret = new String[count];
  for (int i=0; i < count; i++)
    {
    ret[i] = tmp[i];
    }
  return ret;
  }


}
