package viror.teach.anim.net;

import java.beans.*;

/**
 * Title:        Viror.teach.anim.net
 * Description:  
 * Copyright:    Copyright (c) Ralf Gitzel
 * Company:      Wifo III
 * @author Ralf Gitzel
 * @version 1.0
 */

public class LinkBeanInfo extends SimpleBeanInfo
{
  Class beanClass = Link.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public LinkBeanInfo()
  {
  }
  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _bandwidth = new PropertyDescriptor("bandwidth", beanClass, "getBandwidth", "setBandwidth");
      _bandwidth.setDisplayName("Bandwidth");
      _bandwidth.setShortDescription("Bandwidth in abstract measurement");
      PropertyDescriptor _cost = new PropertyDescriptor("cost", beanClass, "getCost", "setCost");
      _cost.setDisplayName("Cost");
      _cost.setShortDescription("Cost of the connection");
      PropertyDescriptor _errorRate = new PropertyDescriptor("errorRate", beanClass, "getErrorRate", "setErrorRate");
      _errorRate.setDisplayName("Error Rate");
      _errorRate.setShortDescription("Likelyhood of package damage");
      PropertyDescriptor _lossRate = new PropertyDescriptor("lossRate", beanClass, "getLossRate", "setLossRate");
      _lossRate.setDisplayName("Loss Rate");
      _lossRate.setShortDescription("Likelyhood of package loss.");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _bandwidth,
	      _cost,
	      _errorRate,
	      _lossRate};
      return pds;
    



}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }
  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
  public BeanInfo[] getAdditionalBeanInfo()
  {
    Class superclass = beanClass.getSuperclass();
    try
    {
      BeanInfo superBeanInfo = Introspector.getBeanInfo(superclass);
      return new BeanInfo[] { superBeanInfo };
    }
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }
}