
package viror.teach.anim.net;

import viror.teach.anim.*;
import java.beans.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class LinkCustomizer extends JPanel implements UndoCustomizer
{

/** The object that will be shown by this Customizer */
Link Data;

/** The intro text for the link description */
private String LinkText = "Link: ";

/** Info Text */
private JLabel BandwidthText = new JLabel("Bandwidth: ");

/** Info Text */
private JLabel LossRateText = new JLabel("Loss Rate: ");

/** Info Text */
private JLabel CostText = new JLabel("Cost: ");

/** Info Text */
private JLabel DelayText = new JLabel("Delay: ");

/** Info Text */
private JLabel ErrorRateText = new JLabel("Error Rate: ");

/** The Link Description */
private JLabel LinkDesc;

/** The Data Field */
private JTextField Bandwidth;

/** The Data Field */
private JTextField LossRate;

/** The Data Field */
private JTextField Cost;

/** The Data Field */
private JTextField Delay;

/** The Data Field */
private JTextField ErrorRate;

/** The saved value for undo */
private int UBand, UCost, UDelay;

/** The saved value for undo */
private double ULoss, UError;

/** The listener that will update fields as they change */
LinkCListener Listener;

  /////////////////////

/** The standard constructor is used for beans */
public LinkCustomizer()
    {
    this(true);
    }

/** This constructor is used by getCustomizer of Link */
public LinkCustomizer(boolean edit)
    {
    setLayout(new BorderLayout());

    Listener = new LinkCListener();

    LinkDesc = new JLabel("Link Description");
    add(LinkDesc, BorderLayout.NORTH);

    JPanel low = new JPanel();
    low.setLayout(new GridLayout(5,1));
    add(low, BorderLayout.CENTER);

    low.add(BandwidthText);
    Bandwidth = new JTextField();
    low.add(Bandwidth);
    Bandwidth.addFocusListener(Listener);

    low.add(LossRateText);
    LossRate = new JTextField();
    low.add(LossRate);
    LossRate.addFocusListener(Listener);

    low.add(ErrorRateText);
    ErrorRate = new JTextField();
    low.add(ErrorRate);
    ErrorRate.addFocusListener(Listener);

    low.add(CostText);
    Cost = new JTextField();
    low.add(Cost);
    Cost.addFocusListener(Listener);

    low.add(DelayText);
    Delay = new JTextField();
    low.add(Delay);
    Delay.addFocusListener(Listener);

    // editable
    if (!edit)
      {
      Bandwidth.setEnabled(false);
      LossRate.setEnabled(false);
      ErrorRate.setEnabled(false);
      Cost.setEnabled(false);
      Delay.setEnabled(false);
      }

    }


/** Pass the object that this customizer will display/alter */
public void setObject(Object data)
    {
    Data = (Link) data;
    String temp = LinkText + Data.getStart() + " - " + Data.getEnd();
    LinkDesc.setText(temp);
    Bandwidth.setText(""+Data.getBandwidth());
    UBand = Data.getBandwidth();
    LossRate.setText(""+Data.getLossRate());
    ULoss = Data.getLossRate();
    Cost.setText(""+Data.getCost());
    UCost = Data.getCost();
    Delay.setText(""+Data.getDelay());
    UDelay = Data.getDelay();
    ErrorRate.setText(""+Data.getErrorRate());
    UError = Data.getErrorRate();
    }

/** Undo the changes to the object */
public void undo()
    {
    try
      {
      Data.setBandwidth(UBand);
      Data.setCost(UCost);
      Data.setDelay(UDelay);
      Data.setLossRate(ULoss);
      Data.setErrorRate(UError);
      } catch (PropertyVetoException e)
	{
	// cannot occur
	System.err.println("Serious error in LinkCustomizer!!!!");
	}
    }

/** A small helper class that reacts to changes of the test fields.
 As soon as a text field looses focus, the new value is tested and
 hopefully accepted. */
class LinkCListener implements FocusListener
{

public void focusGained(FocusEvent e)
    {
    }

public void focusLost(FocusEvent e)
    {
    if (e.getSource() == Bandwidth)
      {
      try
       {
       int i = new Integer(Bandwidth.getText()).intValue();
       Data.setBandwidth(i);
       } catch(Exception ex)
	 {
	 Bandwidth.setText(""+UBand);
	 }
      }
    if (e.getSource() == LossRate)
      {
      try
       {
       double i = new Double(LossRate.getText()).doubleValue();
       Data.setLossRate(i);
       } catch(Exception ex)
	 {
	 LossRate.setText(""+ULoss);
	 }
      }
    if (e.getSource() == ErrorRate)
      {
      try
       {
       double i = new Double(ErrorRate.getText()).doubleValue();
       Data.setErrorRate(i);
       } catch(Exception ex)
	 {
	 ErrorRate.setText(""+UError);
	 }
      }
    if (e.getSource() == Cost)
      {
      try
       {
       int i = new Integer(Cost.getText()).intValue();
       Data.setCost(i);
       } catch(Exception ex)
	 {
	 Cost.setText(""+UCost);
	 }
      }
    if (e.getSource() == Delay)
      {
      try
       {
       int i = new Integer(Delay.getText()).intValue();
       Data.setDelay(i);
       } catch(Exception ex)
	 {
	 Delay.setText(""+UDelay);
	 }
      }
    }

}

}
