package viror.teach.anim.net;

import java.beans.*;

/**
 * Title:        Viror.teach.anim.net
 * Description:  
 * Copyright:    Copyright (c) Ralf Gitzel
 * Company:      Wifo III
 * @author Ralf Gitzel
 * @version 1.0
 */

public class OOComponentBeanInfo extends SimpleBeanInfo
{
  Class beanClass = OOComponent.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public OOComponentBeanInfo()
  {
  }
  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _methodNames = new PropertyDescriptor("methodNames", beanClass, "getMethodNames", null);
      _methodNames.setDisplayName("Method Names");
      _methodNames.setShortDescription("The names of the methods available in this component");
      PropertyDescriptor _methodsEnabled = new PropertyDescriptor("methodsEnabled", beanClass, "isMethodsEnabled", "setMethodsEnabled");
      _methodsEnabled.setDisplayName("Methods Enabled?");
      _methodsEnabled.setShortDescription("If true, this component can send packages");
      PropertyDescriptor _propertyNames = new PropertyDescriptor("propertyNames", beanClass, "getPropertyNames", null);
      _propertyNames.setDisplayName("Property Names");
      _propertyNames.setShortDescription("The properties available in this component");
      PropertyDescriptor _synchronized = new PropertyDescriptor("synchronized", beanClass, "isSynchronized", "setSynchronized");
      _synchronized.setDisplayName("Synchronization?");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _methodNames,
	      _methodsEnabled,
	      _propertyNames,
	      _synchronized};
      return pds;
    



}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }
  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}