package viror.teach.anim.net;

import java.beans.*;

/**
 * Title:        Viror.teach.anim.net
 * Description:  
 * Copyright:    Copyright (c) Ralf Gitzel
 * Company:      Wifo III
 * @author Ralf Gitzel
 * @version 1.0
 */

public class PackageBeanInfo extends SimpleBeanInfo
{
  Class beanClass = Package.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public PackageBeanInfo()
  {
  }
  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _PSize = new PropertyDescriptor("PSize", beanClass, "getPSize", "setPSize");
      _PSize.setDisplayName("Package Size");
      _PSize.setShortDescription("Abstract measure of the size of this package - together with the link bandwidth, this influences speed");
      PropertyDescriptor _type = new PropertyDescriptor("type", beanClass, "getType", "setType");
      _type.setDisplayName("Package Type");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _PSize,
	      _type};
      return pds;
    

}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }
  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}