

package viror.teach.anim.net;

/**
 * This listener can be notified of syntactically incorrect packages by
 * a PackagePedanticHandler. There is no standard implementation for
 * this - reactions to errors are highly context specific and can vary
 * from informative text to exploding routers. Also note that errors
 * are most likely user errors, even  though this class is also useable
 * to handle "simulated" errors like bit flipping etc.
 * @author Ralf Gitzel
 * @version 1.0
 */
public interface PackageErrorListener
{

/** @param p The package that is corrupt
 *  @param h The handler that detected the error
 *  @param errorcode Some userdefined error code.
 */
void errorOccured(Package p, PackagePedanticHandler h, int errorcode);

}