
package viror.teach.anim.net;

/** These package handlers demand a certain systax from their packages and will
 *  notify PackageErrorListeners if the syntax is violated.
 */
public interface PackagePedanticHandler extends PackageHandler
{

/** verifies whether a package conforms to the syntax required. Note that this
 *  is only a generic syntax check, i.e. is the right type of Payload at the
 *  right position. Errors may also occur because of other reasons.
 */
boolean checkSyntax(Package p);

/** informs all PackageErrorListeners that a package was invalid.
 *  @param p       The package that caused the error
 *  @param origin  The handler that detected the error
 *  @param code    An error code that can be used in the listeners to
 *                 further analyse what happened.
 */
void firePackageError(Package p, PackagePedanticHandler origin, int code);

void addErrorListener(PackageErrorListener r);

void removeErrorListener(PackageErrorListener r);

}