package viror.teach.anim.net;

import java.beans.*;

/**
 * Title:        Viror.teach.anim.net
 * Description:  
 * Copyright:    Copyright (c) Ralf Gitzel
 * Company:      Wifo III
 * @author Ralf Gitzel
 * @version 1.0
 */

public class RouterBeanInfo extends SimpleBeanInfo
{
  Class beanClass = Router.class;
  String iconColor16x16Filename;
  String iconColor32x32Filename;
  String iconMono16x16Filename;
  String iconMono32x32Filename;

  public RouterBeanInfo()
  {
  }
  public PropertyDescriptor[] getPropertyDescriptors()
  {
    try
    {
      PropertyDescriptor _handler = new PropertyDescriptor("handler", beanClass, "getHandler", "setHandler");
      _handler.setDisplayName("Package Handler");
      PropertyDescriptor _hostname = new PropertyDescriptor("hostname", beanClass, "getHostname", "setHostname");
      _hostname.setDisplayName("Hostname");
      PropertyDescriptor _IPAddress = new PropertyDescriptor("IPAddress", beanClass, "getIPAddress", "setIPAddress");
      _IPAddress.setDisplayName("IP-Address");
      PropertyDescriptor _packageLayer = new PropertyDescriptor("packageLayer", beanClass, "getPackageLayer", "setPackageLayer");
      _packageLayer.setDisplayName("Package Layer");
      _packageLayer.setShortDescription("On which animation layer should new packages be sent");
      PropertyDescriptor _verbose = new PropertyDescriptor("verbose", beanClass, "isVerbose", "setVerbose");
      _verbose.setDisplayName("Verbose?");
      PropertyDescriptor[] pds = new PropertyDescriptor[] {
	      _handler,
	      _hostname,
	      _IPAddress,
	      _packageLayer,
	      _verbose};
      return pds;
    




}
    catch(IntrospectionException ex)
    {
      ex.printStackTrace();
      return null;
    }
  }
  public java.awt.Image getIcon(int iconKind)
  {
    switch (iconKind) {
    case BeanInfo.ICON_COLOR_16x16:
        return iconColor16x16Filename != null ? loadImage(iconColor16x16Filename) : null;
    case BeanInfo.ICON_COLOR_32x32:
        return iconColor32x32Filename != null ? loadImage(iconColor32x32Filename) : null;
    case BeanInfo.ICON_MONO_16x16:
        return iconMono16x16Filename != null ? loadImage(iconMono16x16Filename) : null;
    case BeanInfo.ICON_MONO_32x32:
        return iconMono32x32Filename != null ? loadImage(iconMono32x32Filename) : null;
        }
    return null;
  }
}