

package viror.teach.anim.net;

import viror.teach.anim.*;
import javax.swing.*;
import javax.swing.border.BevelBorder;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.util.*;

/** The GUI component that will allow custom settings for the router. */
public class RouterCustomizer extends JPanel implements UndoCustomizer
{

JTextField Hostname;
JTextField IPAddress;
JTextArea  Description;
JPanel     PackageHandler;

private boolean Editable;

private String HostnameText       = "Host:";
private String IPAddressText      = "IP-Address:" ;
private String DescriptionText    = "Description";
private String PackageHandlerText = "Software";

/** Undo variables */
private String UHost, UDesc;

/** Undo variables */
private long UIP;

PropertyChangeSupport ListenerList;
Router Data;

  ////////////

/** The standard costructor is used by bean tools. */
public RouterCustomizer()
    {
    this(true);
    }

/** The constructor. If editable is true, the fields are all
    activated. */
public RouterCustomizer(boolean editable)
    {
    RouterCListener rcl = new RouterCListener();
    Editable = editable;
    ListenerList = new PropertyChangeSupport(this);
    setLayout(new BorderLayout());
    JPanel up = new JPanel();
    up.setLayout(new GridLayout(2,2));
    JPanel center = new JPanel();
    center.setLayout(new GridLayout(2,1));
    JPanel desc = new JPanel(new BorderLayout());

    JLabel h = new JLabel(HostnameText);
    Hostname = new JTextField();
    Hostname.addFocusListener(rcl);
    up.add(h);
    up.add(Hostname);

    JLabel i  = new JLabel(IPAddressText);
    IPAddress = new JTextField();
    IPAddress.addFocusListener(rcl);
    up.add(i);
    up.add(IPAddress);

    add(up, BorderLayout.NORTH);

    JLabel d = new JLabel(DescriptionText);
    Description = new JTextArea();
    Description.addFocusListener(rcl);
    desc.add(d, BorderLayout.NORTH);
    desc.add(Description, BorderLayout.CENTER);
    center.add(desc);

    PackageHandler = new JPanel();
    PackageHandler.setBorder(new BevelBorder(BevelBorder.LOWERED));
    center.add(PackageHandler);

    add(center, BorderLayout.CENTER);
    }

  /** Pass the object that this customizer will display/alter */
  public void setObject(Object data)
    {
    Data = (Router) data;
    UIP = Data.getIPAddress();
    UHost = Data.getHostname();
    UDesc = Data.getDescription();
    IPAddress.setText(""+Data.getIPAddress());
    IPAddress.setEnabled(Editable);
    Hostname.setText(Data.getHostname());
    Hostname.setEnabled(Editable);
    Description.setText(Data.getDescription());
    Description.setEnabled(Editable);
    JComponent ph = Data.getHandler().getCustomizer(Editable);
    PackageHandler.add(ph);
    ((Customizer) ph).setObject(Data.getHandler());
    }

  public void setPropertyChangeListener(PropertyChangeListener p)
    {
      ListenerList.addPropertyChangeListener(p);
    }

  public void removePropertyChangeListener(PropertyChangeListener p)
    {
      ListenerList.removePropertyChangeListener(p);
    }



public void undo()
    {
    Data.setHostname(UHost);
    Data.setDescription(UDesc);
    Data.setIPAddress(UIP);
    try
      {
      ((UndoCustomizer) PackageHandler).undo();
      } catch (Exception ex)
        {
        // undo only possible if the customizer conforms to standard
        }
    }

class RouterCListener implements FocusListener
  {

  public void focusGained(FocusEvent e)
    {
    }

  public void focusLost(FocusEvent e)
    {
    if (e.getSource() == Hostname)
      {
      Data.setHostname(Hostname.getText());
      }
    if (e.getSource() == Description)
      {
      Data.setDescription(Description.getText());
      }
    if (e.getSource() == IPAddress)
      {
      try
        {
        long ip = new Long(IPAddress.getText()).longValue();
        Data.setIPAddress(ip);
        } catch (Exception ex)
            {
            // value not changed and that's it...
            IPAddress.setText(""+UIP);
            }
      }
    }
  }

}
