

package viror.teach.anim.net;

import javax.swing.*;
import java.awt.*;
import java.beans.PropertyChangeListener;
import viror.teach.anim.UndoCustomizer;

/**
 * This is not a real customizer but rather a cheap alternative when the
 * customizer should be used for display purposes only. This version (as
 * opposed to RouterCustomizer) is somewhat less space intensive and also hides
 * all PackageHandler-Info. Note that this 'customizer' is never editable no
 * matter what parameter is set.
 * @author Ralf Gitzel
 * @version 1.0
 */
public class RouterSummary extends JPanel implements UndoCustomizer
{

private JLabel Title;
private JTextArea Description;
private Router Data;

/** Note: editable is always false - this 'Customizer' cannot be used for editing. */
public RouterSummary()
  {
  setLayout(new BorderLayout());
  Description = new JTextArea();
  Title = new JLabel();
  add(Description, BorderLayout.CENTER);
  add(Title, BorderLayout.NORTH);
  }

  public void undo()
  {
  // not needed....
  }

public void setObject(Object bean)
  {
  Data = (Router) bean;
  Description.setText(Data.getDescription());
  long ip = Data.getIPAddress();
  if (ip == 0l) Title.setText(Data.getHostname());
  else Title.setText(Data.getHostname() + " ("+ip+")");
  }

public void addPropertyChangeListener(PropertyChangeListener listener)
  {
    //TODO: Implement this java.beans.Customizer method
  }

public void removePropertyChangeListener(PropertyChangeListener listener)
  {
    //TODO: Implement this java.beans.Customizer method
  }


}