
//Titel:Viror Animationsbibliothek
//Version:
//Autor:Ralf Gitzel
//Firma:
//Beschreibung:Diese Sammlung von JavaBeans liefert eine grundlegende Bibliothek
//zur Erstellung von TeachWare, welche Animationen verwendet.

package viror.teach.anim.net;

import viror.teach.anim.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class TestNetFrame extends Frame
{

  private TestNet app;

  //Frame konstruieren
  BorderLayout borderLayout1 = new BorderLayout();

  public TestNetFrame(TestNet t)
  {
    app = t;
    try
    {
      jbInit();
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }

  }
//Initialisierung der Komponente

  private void jbInit() throws Exception
  {

    // stolen from the same source as the code for getURL.
    Image cof = app.getImage(app.getURL("RedMachine.gif"));
    Image sel = app.getImage(app.getURL("RedSelected.gif"));
    Image hpipe = app.getImage(app.getURL("h_pipe.gif"));
    MediaTracker m = new MediaTracker(app);
    m.addImage(cof, 0);
    m.addImage(sel, 0);
    m.addImage(hpipe, 0);
    try { m.waitForAll(); } catch (Exception e) {}
    final SimpleAnimList a = new SimpleAnimList();
    a.setFrameRate(10);
    Package[] tester = new Package[3];
    Router t1 = new Router(cof, sel, 30, 50);
    t1.setHostname("www.cheap-packages.com");
    Router t2 = new Router(cof, sel, 75, 75);
    t2.setHostname("www.wifo3.uni-mannheim.de");
    Router t3 = new Router(cof, sel, 80, 50);
    t3.setHostname("www.newhost.de");
    ((SimpleParseHandler) t2.getHandler()).addEntry(0, "tableBeep", 1, t1);
    ((SimpleParseHandler) t1.getHandler()).addEntry(1, "", 0, t2);
    Link test2  = new Link();
    test2.setStart(t1);
    test2.setStartTangent(0,0);
    test2.setEnd(t2);
    test2.setEndTangent(0,0);
    test2.generateRepresentation();
    //pipe.setStart(t1);
    //pipe.setEnd(t3);
    for (int i = 0; i < 2 ; i++)
      {
	tester[i] = new Package(0,VectorRep.SQUARE,Color.blue);
	test2.placePackage(t1, tester[i]);
      }
    tester[1].setCompletion(50);
    Dimension[] line = new Dimension[4];
    for(int i=0; i < 4; i++) line[i] = new Dimension();
    line[0].width = 50;  line[0].height = 50;
    line[1].width = 100; line[1].height = 50;
    line[2].width = 50;  line[2].height = 100;
    line[3].width = 50;  line[3].height = 75;
    OrnamentalComponent poly = new OrnamentalComponent(cof, sel);
    OOComponent ooboy = new OOComponent(cof, sel);
    this.setLayout(borderLayout1);
    this.setTitle("TestApp fuer AnimBibliothek - nicht verwenden!");
    final AnimDisplay dis = new AnimDisplay(AnimDisplay.SQUARE, 500, 500, a);
    dis.setScreenUsage(.3);
    this.add(dis, BorderLayout.CENTER);
    StandardButtons b = new StandardButtons();
    b.setAList(a);
    b.setAnimControl(a);
    b.addInsertButton("Insert Router", t3);
    b.addInsertButton("Insert Ornamental", poly);
    b.addInsertButton("Insert OO", ooboy);
    b.setConnectType(test2);
    this.add(b, BorderLayout.SOUTH);
    this.pack();
    this.addKeyListener(a);
    this.addFocusListener(new FocusAdapter()
			  {
			  public void focusGained(FocusEvent e)
			    {
			    System.out.println("Focus gained!");
			    }
			  });
    this.addWindowListener(new WindowAdapter()
			   {
			   public void windowActivated(WindowEvent e)
			     {
			     System.out.println("Window activated!");
			     }
			   public void windowDeactivated(WindowEvent e)
			     {
			     System.out.println("Window deactivated!");
			     }
			   });
    a.addElement(1, t1);
    a.addElement(1, t2);
    //a.addElement(1, t3);
    for(int i=0; i<2;i++) a.addElement(2, tester[i]);
    a.addElement(0, test2);
    //a.addElement(0, pipe);
    a.start();



    String[] lines = {"SEND PACKAGE P", "WAIT TIMEOUT", "bla1",
		      "bla2", "bla3","bla4","bla5","bla6","bla7",
		      "bla8","bla9" };
    JFrame side = new JFrame();
    HighlightText pi = new HighlightText();
    pi.setLines(lines);
    ((Progressive) t2.getHandler()).addProgressIndicator(pi);
    side.getContentPane().add(pi);
    side.pack();
    side.setVisible(true);
  }

}











